/* SampleUserControl.cls */

USING Infragistics.Win.UltraWinEditors.* FROM ASSEMBLY.
USING Infragistics.Win.Misc.* FROM ASSEMBLY.

CLASS SampleUserControl INHERITS Progress.Windows.UserControl:

  /* Class private data */
  DEFINE PRIVATE VARIABLE rPasswordEditor AS CLASS UltraTextEditor NO-UNDO.
  DEFINE PRIVATE VARIABLE rLoginButton AS CLASS UltraButton NO-UNDO.

  /* Class public members */
  DEFINE PUBLIC PROPERTY PasswordEntry AS CLASS UltraTextEditor NO-UNDO
    GET.
    PRIVATE SET.

  DEFINE PUBLIC PROPERTY LoginButton AS CLASS UltraButton NO-UNDO
    GET.
    PRIVATE SET.

  CONSTRUCTOR PUBLIC SampleUserControl( ):    
    InitializeComponent( ).    
  END CONSTRUCTOR.

  METHOD PRIVATE VOID InitializeComponent( ):

    /* Initializes extended user control container class with  
       controls and initializes public properties to access them */ 
    rPasswordEditor = NEW UltraTextEditor( ).
    PasswordEntry = rPasswordEditor.
    rLoginButton = NEW UltraButton( ).
    LoginButton = rLoginButton.
    
    CAST(rPasswordEditor,System.ComponentModel.ISupportInitialize):BeginInit( ).
    THIS-OBJECT:SuspendLayout( ).

    /* Set properties */
    rPasswordEditor:Location = NEW System.Drawing.Point( 20, 0 ).
    rPasswordEditor:Size = NEW System.Drawing.Size( 150, 21 ).
    rPasswordEditor:TabIndex = 0.
    rPasswordEditor:Text = "".
    rPasswordEditor:PasswordChar = "*".
    
    rLoginButton:Text = "Login".
    rLoginButton:Location = NEW System.Drawing.Point( 20, 31 ).
    rLoginButton:Size = NEW System.Drawing.Size( 75, 30 ).
    rPasswordEditor:TabIndex = 1.

    THIS-OBJECT:AutoScaleDimensions = NEW System.Drawing.SizeF( 6, 13 ).
    THIS-OBJECT:AutoScaleMode = System.Windows.Forms.AutoScaleMode:Font.

    /* Add controls to form */
    THIS-OBJECT:Controls:Add( rPasswordEditor ).
    THIS-OBJECT:Controls:Add( rLoginButton ).
    THIS-OBJECT:ClientSize = NEW System.Drawing.Size( 200, 200 ).

    CAST(rPasswordEditor,System.ComponentModel.ISupportInitialize):EndInit( ).
    THIS-OBJECT:ResumeLayout( FALSE ).
    THIS-OBJECT:PerformLayout( ).

  END METHOD.

END CLASS.
