/* Define dtTimestamp as SHARED to illustrate the counterpart to inherited 
   data members in classes (#5 in Table 5.1) */

DEFINE SHARED VARIABLE dtTimestamp AS DATETIME NO-UNDO.            /* 5 */
DEFINE VARIABLE hMsg AS HANDLE NO-UNDO.

PROCEDURE updateTimestamp:
  DEFINE OUTPUT PARAMETER pdtTimeStamp AS DATETIME NO-UNDO.
  ASSIGN
    dtTimestamp = NOW
    pdtTimeStamp = dtTimestamp.
END PROCEDURE.

FUNCTION MessageHandler RETURNS HANDLE (INPUT ProcType AS CHARACTER).
  RUN MsgProc.p PERSISTENT SET hMsg (INPUT ProcType).
  RETURN hMsg.
END FUNCTION.

PROCEDURE CleanUp:
  IF VALID-HANDLE (hMsg) THEN
    DELETE OBJECT hMsg.
END PROCEDURE.
