&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS CustWin 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE cFieldHandles AS CHARACTER  NO-UNDO.

/* These variables are used just by the dynamic browse variation
     of this trigger. */
  DEFINE VARIABLE hBrowse   AS HANDLE     NO-UNDO.
  DEFINE VARIABLE hCalcCol  AS HANDLE     NO-UNDO.
  DEFINE QUERY qOrderLine   FOR OrderLine SCROLLING.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME CustQuery
&Scoped-define BROWSE-NAME OrderBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES Customer Order

/* Definitions for BROWSE OrderBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-OrderBrowse Order.Ordernum Order.OrderDate ~
Order.PromiseDate Order.ShipDate Order.PO 
&Scoped-define ENABLED-FIELDS-IN-QUERY-OrderBrowse 
&Scoped-define QUERY-STRING-OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-OrderBrowse OPEN QUERY OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-OrderBrowse Order
&Scoped-define FIRST-TABLE-IN-QUERY-OrderBrowse Order


/* Definitions for FRAME CustQuery                                      */
&Scoped-define FIELDS-IN-QUERY-CustQuery Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-FIELDS-IN-QUERY-CustQuery Customer.CustNum ~
Customer.Name Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-TABLES-IN-QUERY-CustQuery Customer
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-CustQuery Customer
&Scoped-define OPEN-BROWSERS-IN-QUERY-CustQuery ~
    ~{&OPEN-QUERY-OrderBrowse}
&Scoped-define QUERY-STRING-CustQuery FOR EACH Customer ~
      WHERE Customer.State = "NH" SHARE-LOCK ~
    BY Customer.City
&Scoped-define OPEN-QUERY-CustQuery OPEN QUERY CustQuery FOR EACH Customer ~
      WHERE Customer.State = "NH" SHARE-LOCK ~
    BY Customer.City.
&Scoped-define TABLES-IN-QUERY-CustQuery Customer
&Scoped-define FIRST-TABLE-IN-QUERY-CustQuery Customer


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-TABLES Customer
&Scoped-define FIRST-ENABLED-TABLE Customer
&Scoped-Define ENABLED-OBJECTS BtnFirst BtnNext BtnPrev BtnLast OLineFields ~
cSalesRep OrderBrowse 
&Scoped-Define DISPLAYED-FIELDS Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define DISPLAYED-TABLES Customer
&Scoped-define FIRST-DISPLAYED-TABLE Customer
&Scoped-Define DISPLAYED-OBJECTS OLineFields cSalesRep 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR CustWin AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON BtnFirst 
     LABEL "First" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnLast 
     LABEL "Last" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnNext 
     LABEL "Next" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnPrev 
     LABEL "Prev" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE cSalesRep AS CHARACTER FORMAT "X(256)":U 
     LABEL "SalesRep" 
     VIEW-AS FILL-IN 
     SIZE 27 BY 1 NO-UNDO.

DEFINE VARIABLE OLineFields AS CHARACTER 
     VIEW-AS SELECTION-LIST MULTIPLE SCROLLBAR-VERTICAL 
     SIZE 21 BY 5.24 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY OrderBrowse FOR 
      Order SCROLLING.

DEFINE QUERY CustQuery FOR 
      Customer SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE OrderBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS OrderBrowse CustWin _STRUCTURED
  QUERY OrderBrowse NO-LOCK DISPLAY
      Order.Ordernum FORMAT "zzzzzzzzz9":U
      Order.OrderDate FORMAT "99/99/99":U
      Order.PromiseDate FORMAT "99/99/99":U
      Order.ShipDate FORMAT "99/99/9999":U
      Order.PO FORMAT "x(20)":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 65 BY 6.67 ROW-HEIGHT-CHARS .57 NO-EMPTY-SPACE.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME CustQuery
     BtnFirst AT ROW 1.48 COL 8
     BtnNext AT ROW 1.48 COL 24.6
     BtnPrev AT ROW 1.48 COL 41.2
     BtnLast AT ROW 1.48 COL 58
     OLineFields AT ROW 1.95 COL 81 NO-LABEL
     Customer.CustNum AT ROW 2.91 COL 13.4 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 9 BY 1
     Customer.Name AT ROW 2.91 COL 37 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 32 BY 1
     Customer.Address AT ROW 4.1 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 37 BY 1
     Customer.City AT ROW 5.29 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 27 BY 1
     Customer.State AT ROW 5.29 COL 47 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 22 BY 1
     cSalesRep AT ROW 6.48 COL 13 COLON-ALIGNED
     OrderBrowse AT ROW 7.91 COL 13
     "Show OrderLine Fields:" VIEW-AS TEXT
          SIZE 26 BY .62 AT ROW 1.24 COL 81
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 131.4 BY 15.33.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW CustWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Customers and Orders"
         HEIGHT             = 15.33
         WIDTH              = 131.4
         MAX-HEIGHT         = 16
         MAX-WIDTH          = 144.2
         VIRTUAL-HEIGHT     = 16
         VIRTUAL-WIDTH      = 144.2
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW CustWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME CustQuery
                                                                        */
/* BROWSE-TAB OrderBrowse cSalesRep CustQuery */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
THEN CustWin:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME CustQuery
/* Query rebuild information for FRAME CustQuery
     _TblList          = "Sports2000.Customer"
     _OrdList          = "Sports2000.Customer.City|yes"
     _Where[1]         = "Customer.State = ""NH"""
     _Query            is OPENED
*/  /* FRAME CustQuery */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE OrderBrowse
/* Query rebuild information for BROWSE OrderBrowse
     _TblList          = "sports2000.Order OF sports2000.Customer"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   = sports2000.Order.Ordernum
     _FldNameList[2]   = sports2000.Order.OrderDate
     _FldNameList[3]   = sports2000.Order.PromiseDate
     _FldNameList[4]   = sports2000.Order.ShipDate
     _FldNameList[5]   = sports2000.Order.PO
     _Query            is OPENED
*/  /* BROWSE OrderBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON END-ERROR OF CustWin /* Customers and Orders */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON WINDOW-CLOSE OF CustWin /* Customers and Orders */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnFirst
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnFirst CustWin
ON CHOOSE OF BtnFirst IN FRAME CustQuery /* First */
DO:
  GET FIRST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO BROWSE OrderBrowse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnLast
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnLast CustWin
ON CHOOSE OF BtnLast IN FRAME CustQuery /* Last */
DO:
  GET LAST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO BROWSE OrderBrowse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnNext
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnNext CustWin
ON CHOOSE OF BtnNext IN FRAME CustQuery /* Next */
DO:
  GET NEXT CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO BROWSE OrderBrowse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnPrev
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnPrev CustWin
ON CHOOSE OF BtnPrev IN FRAME CustQuery /* Prev */
DO:
  GET PREV CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO BROWSE OrderBrowse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME OLineFields
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OLineFields CustWin
ON LEAVE OF OLineFields IN FRAME CustQuery
DO:
  DEFINE VARIABLE iField    AS INTEGER    NO-UNDO.
  DEFINE VARIABLE hField    AS HANDLE     NO-UNDO.
  DEFINE VARIABLE hLabel    AS HANDLE     NO-UNDO.
  DEFINE VARIABLE cFields   AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE cField    AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE hBufField AS HANDLE     NO-UNDO.
  DEFINE VARIABLE dRow      AS DECIMAL    NO-UNDO INIT 8.0.


  /* This commented-out code is the first version of this trigger code,
    which illustrates creating dynamic fill-ins and text labels. 
    
  DO iField = 1 TO NUM-ENTRIES(cFieldHandles):
      hField = WIDGET-HANDLE(ENTRY(iField,cFieldHandles)).
      DELETE OBJECT hField NO-ERROR.
  END.

  cFields = OLineFields:SCREEN-VALUE.
  DO iField = 1 TO NUM-ENTRIES(cFields):
      ASSIGN cField = ENTRY(iField, cFields)
             hBufField = BUFFER OrderLine:BUFFER-FIELD(cField).
      CREATE TEXT hLabel
          ASSIGN FRAME = FRAME CustQuery:HANDLE
                 DATA-TYPE = "CHARACTER"
                 FORMAT = "X(" + STRING(LENGTH(hBufField:LABEL) + 1) + ")"
                 WIDTH-CHARS = FONT-TABLE:GET-TEXT-WIDTH-CHARS(hBufField:LABEL + ":")
                 SCREEN-VALUE = hBufField:LABEL + ":"
                 HEIGHT-CHARS = 1
                 ROW = dRow
/*                  COLUMN = 85.0.  -- modified to do colon-aligned labels*/
                 COLUMN = 100.0 - 
                    FONT-TABLE:GET-TEXT-WIDTH-CHARS(hBufField:LABEL + ":").
      CREATE FILL-IN hField 
          ASSIGN DATA-TYPE = hBufField:DATA-TYPE
                 FORMAT = hBufField:FORMAT
                 FRAME = FRAME CustQuery:HANDLE
                 SIDE-LABEL-HANDLE = hLabel
/*                  COLUMN = 85.0 + LENGTH(hBufField:LABEL) + 4  -- ditto*/
                 COLUMN = 102
                 ROW = dRow
                 SCREEN-VALUE = hBufField:BUFFER-VALUE
                 HIDDEN = NO.
      ASSIGN dRow = dRow + 1.0
             cFieldHandles = cFieldHandles + 
                (IF cFieldHandles = "" THEN "" ELSE ",") + 
                   STRING(hLabel) + "," + STRING(hField).
  END.  /* END DO iField */
  
  /* This is the end of the code block for the first version of this trigger,
  which creates dynamic fill-ins and text objects. */
  */

  /* This block of code is the second version of the trigger, which creates
     a dynamic browse to show the selected fields. */
      
  IF VALID-HANDLE(hBrowse) THEN 
      DELETE OBJECT hBrowse.

  CREATE BROWSE hBrowse
    ASSIGN FRAME = FRAME CustQuery:HANDLE
           WIDTH = 50
           DOWN  = 6
           ROW   = 8
           COL   = 82
           ROW-MARKERS = NO
           SENSITIVE   = TRUE
           SEPARATORS  = TRUE
           READ-ONLY   = FALSE
           NO-VALIDATE = YES
           VISIBLE     = TRUE
           QUERY = QUERY qOrderLine:HANDLE.

  cFields = OLineFields:SCREEN-VALUE.
  DO iField = 1 TO NUM-ENTRIES(cFields):
      cField = ENTRY(iField, cFields).
      IF cField = "Price B4 Disc" THEN
          hCalcCol = hBrowse:ADD-CALC-COLUMN
          ("Decimal",           /* Data type */
           ">,>>>,>>9.99",      /* Format */
           "0",                 /* Initial value */
           "Price B4 Disc").    /* column label */
      ELSE hBrowse:ADD-LIKE-COLUMN("OrderLine." + cField).
  END.   /* END DO iField... */
  
  /* You can use code such as this to navigate through
     the columns of a browse dynamically. */
  /* 
  DEFINE VARIABLE hCol AS HANDLE     NO-UNDO.
  DEFINE VARIABLE cCols AS CHARACTER NO-UNDO.
  hCol = hBrowse:FIRST-COLUMN.
  DO WHILE VALID-HANDLE(hCol):
      cCols = cCols + "  " + hCol:LABEL.
      hCol = hCol:NEXT-COLUMN.
  END.
  MESSAGE cCols.
  */
  
  ON ROW-DISPLAY OF hBrowse
      PERSISTENT RUN calcPriceB4Disc.

  OPEN QUERY qOrderLine FOR EACH OrderLine
      WHERE OrderLine.OrderNum = Order.OrderNum.
     
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME OrderBrowse
&Scoped-define SELF-NAME OrderBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OrderBrowse CustWin
ON VALUE-CHANGED OF OrderBrowse IN FRAME CustQuery
DO:
  DEFINE VARIABLE iField AS INTEGER    NO-UNDO.
  DEFINE VARIABLE hField AS HANDLE     NO-UNDO.

  /* This is the first version of this trigger, for the
     dynamic fields and text objects. 
  FIND FIRST OrderLine OF Order.
  DO iField = 2 TO NUM-ENTRIES(cFieldHandles) BY 2:
      hField = WIDGET-HANDLE(ENTRY(iField, cFieldHandles)).
      IF VALID-HANDLE(hField) THEN
          hField:SCREEN-VALUE = "".
  END.
  */
  /* This is the second version of this trigger, for the dynamic browse
     example. */
  OPEN QUERY qOrderLine FOR EACH OrderLine WHERE OrderLine.OrderNum
      = Order.OrderNum.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK CustWin 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN createMenu.
  RUN h-startsuper.p("h-dynsuper.p").
  RUN changeFields.
  APPLY "VALUE-CHANGED" TO OrderBrowse.
  RUN initSelection.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE calcPriceB4Disc CustWin 
PROCEDURE calcPriceB4Disc :
/*------------------------------------------------------------------------------
  Procedure: calcPriceB4Disc
  Purpose:    Calculates the value of the calculated column PriceB4Disc. 
  Parameters:  <none>
------------------------------------------------------------------------------*/
IF VALID-HANDLE(hCalcCol) THEN
          hCalcCol:SCREEN-VALUE = STRING(OrderLine.Price * OrderLine.Qty).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createMenu CustWin 
PROCEDURE createMenu :
/*------------------------------------------------------------------------------
  Purpose:     Creates a dynamic menu for the window
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

DEFINE VARIABLE hMenu     AS HANDLE     NO-UNDO.
DEFINE VARIABLE hSubMenu  AS HANDLE     NO-UNDO.
DEFINE VARIABLE hMenuItem AS HANDLE     NO-UNDO.

    CREATE MENU hMenu.

    CREATE SUB-MENU hSubMenu 
        ASSIGN PARENT = hMenu
               LABEL = "SalesReps".
           
    FOR EACH SalesRep:
        CREATE MENU-ITEM hMenuItem
            ASSIGN PARENT = hSubMenu
                   LABEL = SalesRep.SalesRep + " " + SalesRep.RepName
            TRIGGERS:
              ON CHOOSE PERSISTENT RUN filterCust IN THIS-PROCEDURE.
            END TRIGGERS.
    END.
    
    CREATE MENU-ITEM hMenuItem
        ASSIGN SUBTYPE = "RULE"
               PARENT = hSubMenu.
    
    CREATE MENU-ITEM hMenuItem
        ASSIGN PARENT = hSubMenu
               LABEL = "E&xit"
        TRIGGERS:
          ON CHOOSE PERSISTENT RUN leaveProc IN THIS-PROCEDURE.
        END TRIGGERS.
    
    CURRENT-WINDOW:MENUBAR = hMenu.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI CustWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
  THEN DELETE WIDGET CustWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI CustWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/

  {&OPEN-QUERY-CustQuery}
  GET FIRST CustQuery.
  DISPLAY OLineFields cSalesRep 
      WITH FRAME CustQuery IN WINDOW CustWin.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  ENABLE BtnFirst BtnNext BtnPrev BtnLast OLineFields Customer.CustNum 
         Customer.Name Customer.Address Customer.City Customer.State cSalesRep 
         OrderBrowse 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  VIEW CustWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE filterCust CustWin 
PROCEDURE filterCust :
/*------------------------------------------------------------------------------
  Procedure:  filterCust
  Purpose:    Filters customers by the selected SalesRep menu item. 
------------------------------------------------------------------------------*/
    OPEN QUERY CustQuery FOR EACH Customer 
                  WHERE Customer.SalesRep = ENTRY (1, SELF:LABEL, " ").
    cSalesRep:SCREEN-VALUE IN FRAME CustQuery = SELF:LABEL.
    APPLY "CHOOSE" TO BtnFirst IN FRAME CustQuery.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initSelection CustWin 
PROCEDURE initSelection :
/*------------------------------------------------------------------------------
  Purpose:     Set the selection list to a list of all the fields in the 
               OrderLine table.
  Parameters:  <none>    
------------------------------------------------------------------------------*/
DEFINE VARIABLE hBuffer AS HANDLE     NO-UNDO.
DEFINE VARIABLE iField  AS INTEGER     NO-UNDO.
    
    hBuffer = BUFFER OrderLine:HANDLE.
    DO WITH FRAME CustQuery:
       DO iField = 1 TO hBuffer:NUM-FIELDS:
         OLineFields:ADD-LAST(hBuffer:BUFFER-FIELD(iField):NAME).
       END.
    END.
    OlineFields:ADD-LAST("Price B4 Disc").

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE leaveProc CustWin 
PROCEDURE leaveProc :
/*------------------------------------------------------------------------------
  Procedure:   leaveProc
  Purpose:     Handles the Exit menu item
------------------------------------------------------------------------------*/
     APPLY "CLOSE" TO THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

