/* h-OrderCalcs.p */

DEFINE INPUT  PARAMETER piOrderNum      AS INTEGER    NO-UNDO.
DEFINE OUTPUT PARAMETER pdOrderPrice    AS DECIMAL    NO-UNDO.
DEFINE OUTPUT PARAMETER pdOrderTotal    AS DECIMAL    NO-UNDO.
DEFINE OUTPUT PARAMETER pcWarehouseList AS CHARACTER  NO-UNDO.
DEFINE OUTPUT PARAMETER pcBestWarehouse AS CHARACTER  NO-UNDO.

DEFINE VARIABLE cItemList AS CHARACTER  NO-UNDO.

FIND order NO-LOCK WHERE Order.orderNum = piOrderNum NO-ERROR.
FOR EACH OrderLine OF Order NO-LOCK:
  ASSIGN 
    pdOrderTotal = pdOrderTotal + OrderLine.ExtendedPrice
    pdOrderPrice = pdOrderPrice + OrderLine.Price * OrderLine.Qty
    cItemList    = cItemList + (IF cItemList = "" THEN "" ELSE ",") + 
                     STRING(ItemNum).   
END.

RUN h-BinCheck.p (INPUT cItemList, OUTPUT pcWarehouseList, OUTPUT pcBestWarehouse).
