&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */
DEFINE PARAMETER BUFFER Order FOR Order.
/* Local Variable Definitions ---                                       */
DEFINE VARIABLE hSource AS HANDLE     NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME OrderFrame

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES Order Customer

/* Definitions for FRAME OrderFrame                                     */
&Scoped-define FIELDS-IN-QUERY-OrderFrame Order.CustNum Order.SalesRep ~
Order.Ordernum Order.OrderDate Order.OrderStatus Order.PO Order.PromiseDate ~
Order.ShipDate 
&Scoped-define QUERY-STRING-OrderFrame FOR EACH Order SHARE-LOCK, ~
      EACH Customer OF Order SHARE-LOCK
&Scoped-define OPEN-QUERY-OrderFrame OPEN QUERY OrderFrame FOR EACH Order SHARE-LOCK, ~
      EACH Customer OF Order SHARE-LOCK.
&Scoped-define TABLES-IN-QUERY-OrderFrame Order Customer
&Scoped-define FIRST-TABLE-IN-QUERY-OrderFrame Order
&Scoped-define SECOND-TABLE-IN-QUERY-OrderFrame Customer


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS iOtherOrder BtnAlign RECT-1 
&Scoped-Define DISPLAYED-FIELDS Order.CustNum Order.SalesRep Order.Ordernum ~
Order.OrderDate Order.OrderStatus Order.PO Order.PromiseDate Order.ShipDate 
&Scoped-define DISPLAYED-TABLES Order
&Scoped-define FIRST-DISPLAYED-TABLE Order
&Scoped-Define DISPLAYED-OBJECTS iOtherOrder 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD dateColor C-Win 
FUNCTION dateColor RETURNS INTEGER
  ( daFirst AS DATE, daSecond AS DATE )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON BtnAlign 
     LABEL "Align Order" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE iOtherOrder AS CHARACTER FORMAT "X(256)":U 
     LABEL "Other Order" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 48 BY 1.43.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY OrderFrame FOR 
      Order, 
      Customer SCROLLING.
&ANALYZE-RESUME

/* ************************  Frame Definitions  *********************** */

DEFINE FRAME OrderFrame
     Order.CustNum AT ROW 1.24 COL 15 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 9 BY 1
     Order.SalesRep AT ROW 1.24 COL 51 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 9.6 BY 1
     Order.Ordernum AT ROW 2.67 COL 15 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     Order.OrderDate AT ROW 2.67 COL 51 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 13.2 BY 1
     Order.OrderStatus AT ROW 3.86 COL 15 COLON-ALIGNED
          VIEW-AS COMBO-BOX 
          LIST-ITEMS "Ordered","Back Ordered","Partially Shipped","Shipped" 
          DROP-DOWN-LIST
          SIZE 25.6 BY 1
     Order.PO AT ROW 3.86 COL 51 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 22 BY 1
     Order.PromiseDate AT ROW 5.05 COL 15 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 13.2 BY 1
     Order.ShipDate AT ROW 5.05 COL 51 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 16 BY 1
     iOtherOrder AT ROW 6.71 COL 39 COLON-ALIGNED
     BtnAlign AT ROW 6.71 COL 56
     RECT-1 AT ROW 6.48 COL 25
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 80 BY 7.05.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Order Detail"
         HEIGHT             = 7.05
         WIDTH              = 80
         MAX-HEIGHT         = 16
         MAX-WIDTH          = 80
         VIRTUAL-HEIGHT     = 16
         VIRTUAL-WIDTH      = 80
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME OrderFrame
                                                                        */
/* SETTINGS FOR FILL-IN Order.CustNum IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Order.OrderDate IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Order.Ordernum IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR COMBO-BOX Order.OrderStatus IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Order.PO IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Order.PromiseDate IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Order.SalesRep IN FRAME OrderFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Order.ShipDate IN FRAME OrderFrame
   NO-ENABLE                                                            */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME OrderFrame
/* Query rebuild information for FRAME OrderFrame
     _TblList          = "sports2000.Order,sports2000.Customer OF sports2000.Order"
     _Query            is NOT OPENED
*/  /* FRAME OrderFrame */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Order Detail */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Order Detail */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnAlign
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnAlign C-Win
ON CHOOSE OF BtnAlign IN FRAME OrderFrame /* Align Order */
DO:
  DEFINE VARIABLE hOtherWin AS HANDLE     NO-UNDO.
  DEFINE VARIABLE hWindow   AS HANDLE     NO-UNDO.
  RUN fetchOrderWin IN hSource 
      (INPUT iOtherOrder:SCREEN-VALUE,
       OUTPUT hOtherWin).
  IF VALID-HANDLE(hOtherWin) THEN
  DO:
      ASSIGN hWindow = hOtherWin:CURRENT-WINDOW
             hWindow:ROW = THIS-PROCEDURE:CURRENT-WINDOW:ROW + 1
             hWindow:COLUMN = THIS-PROCEDURE:CURRENT-WINDOW:COLUMN + 3.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN h-StartSuper.p (INPUT "h-winsuper.p").  /* add this super procedure */
  RUN enable_UI.

  RUN alignWindow.
  ASSIGN THIS-PROCEDURE:PRIVATE-DATA = STRING(OrderNum)
         hSource = SOURCE-PROCEDURE
         shipDate:BGCOLOR = dateColor(PromiseDate, ShipDate).
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE alignWindow C-Win 
PROCEDURE alignWindow :
/*------------------------------------------------------------------------------
  Purpose:     Local version of alignWindow for OrderWin sets Row to 20.0.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  RUN SUPER.
  THIS-PROCEDURE:CURRENT-WINDOW:ROW = 20.0.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY iOtherOrder 
      WITH FRAME OrderFrame IN WINDOW C-Win.
  IF AVAILABLE Order THEN 
    DISPLAY Order.CustNum Order.SalesRep Order.Ordernum Order.OrderDate 
          Order.OrderStatus Order.PO Order.PromiseDate Order.ShipDate 
      WITH FRAME OrderFrame IN WINDOW C-Win.
  ENABLE iOtherOrder BtnAlign RECT-1 
      WITH FRAME OrderFrame IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-OrderFrame}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION dateColor C-Win 
FUNCTION dateColor RETURNS INTEGER
  ( daFirst AS DATE, daSecond AS DATE ) :
/*------------------------------------------------------------------------------
  Purpose:  Provides a standard warning color if one date 
            is too far from another.
    Notes:  The function returns a color code of:
            -- yellow if the dates differ at all
            -- purple if they are more than five days apart
            -- red if they are more than ten days apart
------------------------------------------------------------------------------*/
  DEFINE VARIABLE iDifference AS INTEGER    NO-UNDO.
  iDifference = daSecond - daFirst.
  RETURN IF iDifference = ? OR iDifference > 10 THEN 12 /* Red */
         ELSE IF iDifference > 5 THEN 13 /* Purple */
         ELSE IF iDifference > 0 THEN 14 /* Yellow */
         ELSE ?.  /* Unknown value keeps the default background color. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

