/* {lt-10-in.i} Common Interface Setup Code */  
 
/**********  DEFINE TRIGGERS  **********/
ON CHOOSE of b-rep DO:  
  OUTPUT TO "tut-temp.txt".
  FOR EACH Customer FIELDS (Balance Name SalesRep) NO-LOCK
    BREAK BY Customer.SalesRep WITH STREAM-IO:
    DISPLAY Customer.SalesRep Customer.Name 
      Customer.Balance (COUNT TOTAL AVERAGE BY Customer.SalesRep).
  END.
  OUTPUT CLOSE.
    
  ASSIGN 
    Rep-Editor:READ-ONLY IN FRAME Dialog1 = TRUE
    Rep-Editor:SENSITIVE IN FRAME Dialog1 = TRUE
    FRAME Dialog1:TITLE = "Report Output"
    lStat = Rep-Editor:READ-FILE("tut-temp.txt") IN FRAME Dialog1.
              
  IF lStat THEN DO:
    ENABLE Rep-Editor b-ok WITH FRAME Dialog1.
    WAIT-FOR GO OF FRAME Dialog1.
    HIDE FRAME Dialog1.
  END.
END. /* ON CHOOSE OF b-rep */

/**********  MAIN LOGIC  **********/
ENABLE ALL WITH FRAME Frame1.
WAIT-FOR CHOOSE OF b-exit.
