/* i-ablpip.p */
/* Reads and writes a Windows named pipe */

/* 1. Define buttons */
DEFINE BUTTON bWrite LABEL "Write to Pipe".
DEFINE BUTTON bRead  LABEL "Read from Pipe".
DEFINE BUTTON bQuit  LABEL "Quit".

/* 2. Define form */
FORM SKIP(5)
  SPACE(5) bWrite SPACE(5) bRead SPACE(5) SKIP(1)
  SPACE(18) bQuit SKIP(5)
  WITH FRAME f TITLE "Pipe Test".

/* 3. Define write trigger */
ON CHOOSE OF bWrite IN FRAME f DO:
  OUTPUT TO \\.\pipe\custpipe APPEND.
  FOR EACH Customer FIELDS (Name) NO-LOCK:
    DISPLAY Customer.Name.
  END.
  OUTPUT CLOSE.
END.

/* 4. Define read trigger */
ON CHOOSE OF bRead IN FRAME f DO:
  DEFINE VARIABLE ix AS INTEGER NO-UNDO.

  INPUT FROM \\.\pipe\custpipe.
  SET ix.
  INPUT CLOSE.
  FIND Customer NO-LOCK WHERE Customer.CustNum = ix.
  DISPLAY Customer WITH 2 COLUMNS FRAME y OVERLAY TITLE "Customer Info".
END.

/* 5. Define quit trigger */
ON CHOOSE OF bQuit IN FRAME f DO:
  APPLY "window-close" TO CURRENT-WINDOW.
END.

/* 6. Enable all objects, then wait on a close event */
ENABLE ALL WITH FRAME f.
WAIT-FOR WINDOW-CLOSE OF CURRENT-WINDOW.
