DO FOR permission:
  FIND permission "print" NO-LOCK.
  IF NOT CAN-DO(can-run) THEN DO:
    MESSAGE "You are not authorized to run this procedure.".
    RETURN.
  END.
END.

/* i-itlst2.p */
FOR EACH Customer NO-LOCK WHERE Customer.CreditLimit > 50000 
  BY Customer.PostalCode:
  DISPLAY Customer.Name Customer.Address Customer.City Customer.State
    Customer.PostalCode Customer.CreditLimit
    WITH SIDE-LABELS.
  FOR EACH Order OF Customer NO-LOCK:
    DISPLAY Order WITH SIDE-LABELS.
    FOR EACH OrderLine OF Order NO-LOCK, Item OF OrderLine NO-LOCK:
      DISPLAY OrderLine.LineNum Item.ItemNum Item.ItemName
        OrderLine.Qty OrderLine.Price WITH SIDE-LABELS.
    END.
  END.
END.
