/* r-browse.p */

DEFINE QUERY q1 FOR Customer. 
DEFINE BROWSE b1 QUERY q1 DISPLAY CustNum Name 
  WITH 17 DOWN TITLE "Customer Browse".

DEFINE FRAME f1 b1
  WITH SIDE-LABELS AT ROW 2 COLUMN 2.
DEFINE FRAME f2
  WITH 1 COLUMNS AT ROW 2 COLUMN 38.

ON VALUE-CHANGED OF b1 DO:
  DISPLAY Customer EXCEPT Customer.Comments WITH FRAME f2.
END.
 
OPEN QUERY q1 FOR EACH Customer.
ENABLE b1 WITH FRAME f1.
APPLY "VALUE-CHANGED" TO BROWSE b1.

WAIT-FOR WINDOW-CLOSE OF CURRENT-WINDOW.
