/* r-fill.p */

DEFINE VARIABLE fillchar AS CHARACTER NO-UNDO FORMAT "x" INITIAL "*".
DEFINE VARIABLE percentg AS INTEGER   NO-UNDO FORMAT ">>9".

FOR EACH Customer NO-LOCK:
  ACCUMULATE Customer.Balance (TOTAL).
END.

DISPLAY "Percentage of Outstanding Balance" WITH CENTERED NO-BOX.

FOR EACH Customer NO-LOCK WHERE Customer.Balance > 0:
  percentg = Customer.Balance / (ACCUM TOTAL Customer.Balance) * 100.
  FORM SKIP Customer.Name percentg LABEL "%" bar AS CHARACTER
    LABEL "  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17"
    FORMAT "x(50)" WITH NO-BOX NO-UNDERLINE USE-TEXT.
  COLOR DISPLAY BRIGHT-RED bar.
  DISPLAY Customer.Name percentg FILL(fillchar,percentg * 3) @ bar.
END.
