/* r-iinfo.p */

DEFINE VARIABLE hQuery AS HANDLE  NO-UNDO.
DEFINE VARIABLE ix     AS INTEGER NO-UNDO.
DEFINE VARIABLE jx     AS INTEGER NO-UNDO.

DEFINE QUERY q FOR Customer, Order, OrderLine SCROLLING.

hQuery = QUERY q:HANDLE.
hQuery:QUERY-PREPARE("FOR EACH Customer WHERE Customer.CustNum < 3,
  EACH Order OF Customer, EACH OrderLine").
hQuery:QUERY-OPEN.

MESSAGE "prepare string is" hQuery:PREPARE-STRING.

REPEAT ix = 1 TO hQuery:NUM-BUFFERS:
  jx = LOOKUP("WHOLE-INDEX", hQuery:INDEX-INFORMATION(ix)).
  IF jx > 0 THEN
    MESSAGE "inefficient index" ENTRY(jx + 1, hQuery:INDEX-INFORMATION(ix)). 
  ELSE 
    MESSAGE "bracketed index use of" hQuery:INDEX-INFORMATION(ix).
END.
