/* r-substr.p */

DEFINE VARIABLE inv-num AS CHARACTER NO-UNDO FORMAT "x(11)"
  LABEL "Invoice Number".
DEFINE VARIABLE snum    AS INTEGER   NO-UNDO FORMAT "9999"
  LABEL "  Starting Order Number".
DEFINE VARIABLE enum    LIKE snum    NO-UNDO
  LABEL "    Ending Order Number".
DEFINE VARIABLE num     LIKE snum    NO-UNDO
  LABEL "Starting Invoice Number".

UPDATE "      Creating Invoices" 
  SKIP(2) snum SKIP(1) enum SKIP(2) num SKIP(2)
  WITH SIDE-LABELS CENTERED NO-BOX.

FOR EACH Order WHERE Order.OrderNum >= snum AND Order.OrderNum <= enum:
  inv-num = SUBSTRING(STRING(TODAY),1,2,"CHARACTER") + 
            SUBSTRING(STRING(TODAY),7,2,"CHARACTER") + " - " + 
              STRING(num,"9999").
  DISPLAY Order.OrderNum inv-num WITH CENTERED.
  /* Do creation and printing of invoice here */

  num = num + 1.
END.
