/* r-ttbfld.p -- Extracts a temp-table buffer-field attribute.
   With RCODE-INFORMATION, cLabel is "xx" (the actual value).
   Without RCODE-INFORMATION, cLabel is "cField1" (the default value).
   With NO-ERROR, no warning message appears
   Without NO-ERROR, the warning message appears  */

DEFINE VARIABLE cLabel   AS CHARACTER NO-UNDO.
DEFINE VARIABLE hField   AS HANDLE    NO-UNDO.
DEFINE VARIABLE httTable AS HANDLE    NO-UNDO.

DEFINE TEMP-TABLE ttTable /* RCODE-INFORMATION */
  FIELD cField1 AS CHARACTER LABEL "xx".
  
httTable = BUFFER ttTable:HANDLE.
hField   = httTable:BUFFER-FIELD(1).
cLabel   = hField:LABEL /* NO-ERROR */.

DISPLAY cLabel.
