/* r-valhnd.p */

DEFINE VARIABLE mywin AS HANDLE NO-UNDO.

DEFINE BUTTON mkwin LABEL "New Window".

ON CHOOSE OF mkwin DO:
  CREATE WINDOW mywin ASSIGN 
    VISIBLE          = TRUE
    TITLE            = "Second Window"
    MAX-WIDTH-CHARS  = 40
    MAX-HEIGHT-CHARS = 10.
  SELF:SENSITIVE   = FALSE.
END.

ON WINDOW-CLOSE OF DEFAULT-WINDOW DO:
  IF VALID-HANDLE(mywin) THEN 
    DELETE WIDGET mywin.
END.

ENABLE mkwin.
WAIT-FOR WINDOW-CLOSE OF DEFAULT-WINDOW.
