/* pi-tfx-read-3.p */
/* Provides a new dynamic ProDataSet with XML Schema. */

{pi-tfx-parameterVarDefs.i}

DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.
DEFINE VARIABLE hDSET       AS HANDLE  NO-UNDO.

CREATE DATASET hDSET.
    
ASSIGN
  cSourceType             = "FILE"
  cFile                   = "Dept400.xsd"
  lOverrideDefaultMapping = ?
  cFieldTypeMapping       = ?
  cVerifySchemaMode       = ?.

DISPLAY "Reading XML Schema..." SKIP.
    
returnValue = hDSET:READ-XMLSCHEMA(cSourceType, cFile,
                                   lOverrideDefaultMapping,
                                   cFieldTypeMapping, cVerifySchemaMode).
IF returnValue THEN
  DISPLAY "How many temp-table buffers in the dynamic ProDataSet?" hDSET:NUM-BUFFERS "."

