&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS CustWin 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE cFillIns   AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cBtnChoice AS CHARACTER  NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME CustQuery
&Scoped-define BROWSE-NAME OrderBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES Customer Order

/* Definitions for BROWSE OrderBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-OrderBrowse Order.Ordernum Order.OrderDate ~
Order.PromiseDate Order.ShipDate Order.PO 
&Scoped-define ENABLED-FIELDS-IN-QUERY-OrderBrowse 
&Scoped-define QUERY-STRING-OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-OrderBrowse OPEN QUERY OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-OrderBrowse Order
&Scoped-define FIRST-TABLE-IN-QUERY-OrderBrowse Order


/* Definitions for FRAME CustQuery                                      */
&Scoped-define FIELDS-IN-QUERY-CustQuery Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define OPEN-BROWSERS-IN-QUERY-CustQuery ~
    ~{&OPEN-QUERY-OrderBrowse}
&Scoped-define QUERY-STRING-CustQuery FOR EACH Customer SHARE-LOCK
&Scoped-define OPEN-QUERY-CustQuery OPEN QUERY CustQuery FOR EACH Customer SHARE-LOCK.
&Scoped-define TABLES-IN-QUERY-CustQuery Customer
&Scoped-define FIRST-TABLE-IN-QUERY-CustQuery Customer


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BtnFirst BtnNext BtnPrev BtnLast btnFilter ~
btnRepos BtnFind OrderBrowse 
&Scoped-Define DISPLAYED-FIELDS Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define DISPLAYED-TABLES Customer
&Scoped-define FIRST-DISPLAYED-TABLE Customer


/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR CustWin AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnFilter 
     LABEL "Filter" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnFind 
     LABEL "Find" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnFirst 
     LABEL "First" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnLast 
     LABEL "Last" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnNext 
     LABEL "Next" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnPrev 
     LABEL "Prev" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnRepos 
     LABEL "Reposition" 
     SIZE 15 BY 1.14.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY OrderBrowse FOR 
      Order SCROLLING.

DEFINE QUERY CustQuery FOR 
      Customer SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE OrderBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS OrderBrowse CustWin _STRUCTURED
  QUERY OrderBrowse NO-LOCK DISPLAY
      Order.Ordernum FORMAT "zzzzzzzzz9":U
      Order.OrderDate FORMAT "99/99/99":U
      Order.PromiseDate FORMAT "99/99/99":U
      Order.ShipDate FORMAT "99/99/9999":U
      Order.PO FORMAT "x(20)":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 65 BY 6.67 ROW-HEIGHT-CHARS .57 EXPANDABLE.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME CustQuery
     BtnFirst AT ROW 1.48 COL 8
     BtnNext AT ROW 1.48 COL 24.6
     BtnPrev AT ROW 1.48 COL 41.2
     BtnLast AT ROW 1.48 COL 58
     btnFilter AT ROW 1.48 COL 75
     btnRepos AT ROW 2.91 COL 75
     Customer.CustNum AT ROW 3.38 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 9 BY 1
     Customer.Name AT ROW 3.38 COL 37 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 32 BY 1
     BtnFind AT ROW 4.33 COL 75
     Customer.Address AT ROW 4.57 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 37 BY 1
     Customer.City AT ROW 5.76 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 27 BY 1
     Customer.State AT ROW 5.76 COL 47 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 22 BY 1
     OrderBrowse AT ROW 7.67 COL 13
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 93.4 BY 14.67.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW CustWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Customers and Orders"
         HEIGHT             = 14.67
         WIDTH              = 93.4
         MAX-HEIGHT         = 16
         MAX-WIDTH          = 116
         VIRTUAL-HEIGHT     = 16
         VIRTUAL-WIDTH      = 116
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW CustWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME CustQuery
                                                                        */
/* BROWSE-TAB OrderBrowse State CustQuery */
/* SETTINGS FOR FILL-IN Customer.Address IN FRAME CustQuery
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Customer.City IN FRAME CustQuery
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Customer.CustNum IN FRAME CustQuery
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Customer.Name IN FRAME CustQuery
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Customer.State IN FRAME CustQuery
   NO-ENABLE                                                            */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
THEN CustWin:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME CustQuery
/* Query rebuild information for FRAME CustQuery
     _TblList          = "sports2000.Customer"
     _Query            is OPENED
*/  /* FRAME CustQuery */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE OrderBrowse
/* Query rebuild information for BROWSE OrderBrowse
     _TblList          = "sports2000.Order OF sports2000.Customer"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   = sports2000.Order.Ordernum
     _FldNameList[2]   = sports2000.Order.OrderDate
     _FldNameList[3]   = sports2000.Order.PromiseDate
     _FldNameList[4]   = sports2000.Order.ShipDate
     _FldNameList[5]   = sports2000.Order.PO
     _Query            is OPENED
*/  /* BROWSE OrderBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON END-ERROR OF CustWin /* Customers and Orders */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON WINDOW-CLOSE OF CustWin /* Customers and Orders */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnFilter
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnFilter CustWin
ON CHOOSE OF btnFilter IN FRAME CustQuery /* Filter */
,btnRepos,btnFind
DO:
    DEFINE VARIABLE hContainer AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hField     AS HANDLE     NO-UNDO.
    DEFINE VARIABLE iField     AS INTEGER    NO-UNDO.

    IF cFillIns = "" THEN
    DO:
        /* Identify all the fill-ins so they can be enabled, disabled,
           and cleared. */
        ASSIGN hContainer = FRAME CustQuery:HANDLE
               hContainer = hContainer:FIRST-CHILD. /* The field group */
        hField = hContainer:FIRST-CHILD.
        DO WHILE VALID-HANDLE(hField):
            IF hField:TYPE = "Fill-In" THEN
                cFillIns = cFillIns +
                (IF cFillIns = "" THEN "" ELSE ",") + STRING(hField).
            hField = hField:NEXT-SIBLING.
        END.
    END.
    DO iField = 1 TO NUM-ENTRIES(cFillIns):
        ASSIGN hField = WIDGET-HANDLE(ENTRY(iField, cFillins))
               hField:SCREEN-VALUE = ""
               hField:SENSITIVE = YES.
    END.

    cBtnChoice = SELF:LABEL. /* was this a Filter, Reposition, or Find operation? */

    /* This is the static equivalent of the dynamic code above, but
       it would have to be changed every time a field was added to
       the screen or removed. */
/*   ASSIGN Customer.CustNum:SCREEN-VALUE = "" */
/*          Customer.NAME:SCREEN-VALUE = ""    */
/*          Customer.Address:SCREEN-VALUE = "" */
/*          Customer.City:SCREEN-VALUE = ""    */
/*          Customer.State:SCREEN-VALUE = ""   */
/*          Customer.CustNum:SENSITIVE = YES   */
/*          Customer.NAME:SENSITIVE = YES      */
/*          Customer.Address:SENSITIVE = YES   */
/*          Customer.City:SENSITIVE = YES      */
/*          Customer.State:SENSITIVE = YES.    */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnFirst
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnFirst CustWin
ON CHOOSE OF BtnFirst IN FRAME CustQuery /* First */
DO:
  GET FIRST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnLast
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnLast CustWin
ON CHOOSE OF BtnLast IN FRAME CustQuery /* Last */
DO:
  GET LAST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnNext
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnNext CustWin
ON CHOOSE OF BtnNext IN FRAME CustQuery /* Next */
DO:
  GET NEXT CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnPrev
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnPrev CustWin
ON CHOOSE OF BtnPrev IN FRAME CustQuery /* Prev */
DO:
  GET PREV CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Customer.CustNum
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Customer.CustNum CustWin
ON LEAVE OF Customer.CustNum IN FRAME CustQuery /* Cust Num */
,Customer.NAME,Customer.Address,Customer.City,Customer.State
DO:
  DEFINE VARIABLE hQuery   AS HANDLE     NO-UNDO.
  DEFINE VARIABLE hBuffer  AS HANDLE     NO-UNDO.
  DEFINE VARIABLE cPrepare AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE iField   AS INTEGER    NO-UNDO.
  DEFINE VARIABLE hField   AS HANDLE     NO-UNDO.
  
  IF SELF:SCREEN-VALUE NE "" THEN
  DO:
    DO iField = 1 TO NUM-ENTRIES(cFillIns):
        ASSIGN hField = WIDGET-HANDLE(ENTRY(iField, cFillins))
               hField:SENSITIVE = NO.
    END.
    ASSIGN hQuery = QUERY CustQuery:HANDLE
           cPrepare = hQuery:PREPARE-STRING.
    IF cBtnChoice = "Filter" THEN
    DO:
        /* If the query hasn't been prepared dynamically just restore
           the original query definition. */
        IF cPrepare = ?  THEN  
            cPrepare = "FOR EACH Customer".
        hQuery:QUERY-CLOSE().
        hQuery:QUERY-PREPARE("FOR EACH Customer WHERE " + SELF:NAME +
                             (IF SELF:DATA-TYPE = "CHARACTER" THEN
                                 " BEGINS " ELSE " = ")                           
                             + QUOTER(SELF:SCREEN-VALUE) +
                             " BY " + SELF:NAME).
        IF ENTRY(1, hQuery:INDEX-INFORMATION(1)) = "WHOLE-INDEX" THEN
        DO:
            MESSAGE "This query can't use an index. Continue?"
                 VIEW-AS ALERT-BOX BUTTONS YES-NO SET lContinue AS LOGICAL.
            IF NOT lContinue THEN
                hQuery:QUERY-PREPARE(cPrepare).
        END.
        hQuery:QUERY-OPEN().
        ENABLE BtnFirst BtnNext BtnPrev BtnLast BtnRepos 
            WITH FRAME CustQuery.
        APPLY "CHOOSE" TO btnFirst.
    END.    /* END DO IF "Filter" */
    ELSE IF cBtnChoice = "Reposition" THEN 
    DO: 
        hBuffer = BUFFER Customer:HANDLE.
        hBuffer:FIND-FIRST("WHERE " + SELF:NAME + 
                           (IF SELF:DATA-TYPE = "CHARACTER" THEN " BEGINS " 
                               ELSE " = ") + 
                           QUOTER(SELF:SCREEN-VALUE)) NO-ERROR.
        IF hBuffer:AVAILABLE THEN 
        DO:
          hQuery:REPOSITION-TO-ROWID(hBuffer:ROWID) NO-ERROR.
          APPLY "CHOOSE" TO BtnNext.
        END.   /* END DO IF AVAILABLE Customer */
        IF NOT hBuffer:AVAILABLE THEN 
            MESSAGE "No record matches that value. Try again. ".
    END.       /* END ELSE DO (IF "Reposition" ) */
    ELSE IF cBtnChoice = "Find" THEN
    DO:
        hBuffer = BUFFER Customer:HANDLE.
        hBuffer:FIND-UNIQUE("WHERE " + SELF:NAME + " = " + 
                               QUOTER(SELF:SCREEN-VALUE)) NO-ERROR.
        IF hBuffer:AMBIGUOUS THEN
            MESSAGE "This choice returns more than one row. Try again.".
        ELSE IF NOT hBuffer:AVAILABLE THEN
            MESSAGE "This choice does not match any row. Try again.".
        ELSE DO:
            CLOSE QUERY CustQuery.
            DISABLE BtnFirst BtnNext btnPrev BtnLast BtnRepos
                WITH FRAME CustQuery.
            DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
            Customer.State 
            WITH FRAME CustQuery IN WINDOW CustWin.
            {&OPEN-BROWSERS-IN-QUERY-CustQuery}
        END.   /* END DO IF "Find" */
    END.       /* END ELSE DO IF no errors */
  END.         /* END DO IF SCREEN-VALUE NOT "" */
END.           /* END DO for the trigger block */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME OrderBrowse
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK CustWin 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI CustWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
  THEN DELETE WIDGET CustWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI CustWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/

  {&OPEN-QUERY-CustQuery}
  GET FIRST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  ENABLE BtnFirst BtnNext BtnPrev BtnLast btnFilter btnRepos BtnFind 
         OrderBrowse 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  VIEW CustWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

