/* h-fetchOlines.p - Retrieve all orderlines for an Order and return them in 
   a temp-table. */
{h-ttOline.i}

/* DEFINE TEMP-TABLE ttOline LIKE OrderLine
   FIELD ItemName    LIKE Item.ItemName
   FIELD TotalWeight AS DECIMAL LABEL "Tot.Wgt.". */
       
DEFINE INPUT  PARAMETER piOrderNum AS INTEGER    NO-UNDO.
DEFINE OUTPUT PARAMETER TABLE FOR ttOline.

FOR EACH OrderLine NO-LOCK WHERE Orderline.OrderNum = piOrderNum, 
  Item OF OrderLine NO-LOCK:
  CREATE ttOline.
  BUFFER-COPY OrderLine TO ttOline
    ASSIGN ttOline.ItemName    = Item.ItemName
           ttOline.TotalWeight = OrderLine.Qty * Item.Weight.
END.
