/* i-attnam.p */
DEFINE VARIABLE hDoc  AS HANDLE  NO-UNDO.
DEFINE VARIABLE hRoot AS HANDLE  NO-UNDO.
DEFINE VARIABLE good  AS LOGICAL NO-UNDO.

CREATE X-DOCUMENT hDoc.
CREATE X-NODEREF hRoot.

hDoc:LOAD("file", "personal.xml", TRUE).
hDoc:GET-DOCUMENT-ELEMENT(hRoot).

RUN GetChildren(hRoot, 1).

DELETE OBJECT hDoc.
DELETE OBJECT hRoot.

PROCEDURE GetChildren:
  DEFINE INPUT PARAMETER hParent AS HANDLE  NO-UNDO.
  DEFINE INPUT PARAMETER level   AS INTEGER NO-UNDO.
  
  DEFINE VARIABLE ix       AS INTEGER NO-UNDO.
  DEFINE VARIABLE hNoderef AS HANDLE  NO-UNDO.

  CREATE X-NODEREF hNoderef.

  REPEAT ix = 1 TO hParent:NUM-CHILDREN:
    good = hParent:GET-CHILD(hNoderef, ix).
    IF NOT good THEN LEAVE.
    IF hNoderef:SUBTYPE <> "element" THEN NEXT.
    IF hNoderef:NAME = "person" THEN
      MESSAGE "getattr id gives" hNoderef:GET-ATTRIBUTE("id")
        hNoderef:ATTRIBUTE-NAMES.
    RUN GetChildren(hNoderef, (level + 1)).
  END.

  DELETE OBJECT hNoderef.
END PROCEDURE.
