/* pi-write-json-tt.i */
/* Definition of a temp-table. */

DEFINE TEMP-TABLE ttCust 
  FIELD CustNum      LIKE Customer.CustNum
  FIELD Country      LIKE Customer.Country
  FIELD Name         LIKE Customer.Name
  FIELD Address      LIKE Customer.Address
  FIELD Address2     LIKE Customer.Address2
  FIELD City         LIKE Customer.City
  FIELD State        LIKE Customer.State
  FIELD PostalCode   LIKE Customer.PostalCode
  FIELD Contact      LIKE Customer.Contact
  FIELD Phone        LIKE Customer.Phone
  FIELD SalesRep     LIKE Customer.SalesRep
  FIELD CreditLimit  LIKE Customer.CreditLimit
  FIELD Balance      LIKE Customer.Balance
  FIELD Terms        LIKE Customer.Terms
  FIELD Discount     LIKE Customer.Discount
  FIELD Comments     LIKE Customer.Comments
  FIELD Fax          LIKE Customer.Fax
  FIELD EmailAddress LIKE Customer.EmailAddress
  
  INDEX CountryPost Country PostalCode 
  INDEX Comments IS WORD-INDEX Comments
  INDEX CustNum IS UNIQUE PRIMARY CustNum
  INDEX NAME NAME
  INDEX SalesRep SalesRep.
