/* r-altbox.p */

DEFINE VARIABLE cust-list AS CHARACTER NO-UNDO
  VIEW-AS SELECTION-LIST SINGLE SIZE 50 BY 10 LABEL "Customers".
DEFINE VARIABLE ok-status AS LOGICAL   NO-UNDO

FORM cust-list
  WITH FRAME sel-frame.

ON DEFAULT-ACTION OF cust-list DO:
  MESSAGE "You have chosen to delete" cust-list:SCREEN-VALUE + "." SKIP(1)
    "Do you really want to delete this customer?"
    VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO-CANCEL
    TITLE "" UPDATE lChoice AS LOGICAL.
  CASE lChoice:
    WHEN TRUE THEN DO:
      FIND Customer WHERE Customer.Name = cust-list:SCREEN-VALUE
        EXCLUSIVE-LOCK.
      DELETE Customer.
    END.
    WHEN FALSE THEN DO:
      MESSAGE "Deletion canceled."
        VIEW-AS ALERT-BOX INFORMATION BUTTONS OK.
      RETURN NO-APPLY.
    END.
    OTHERWISE /* Cancel */ STOP.
  END CASE.
END.

FOR EACH Customer NO-LOCK BY Customer.Name:
  ok-status = cust-list:ADD-LAST(Customer.Name).
END. 

ENABLE cust-list WITH FRAME sel-frame.
WAIT-FOR WINDOW-CLOSE OF CURRENT-WINDOW.
