DEFINE BUTTON btnFind LABEL "Find Customer".

DO WITH FRAME frCustomer WITH SIDE-LABELS:
  ENABLE Customer.CustNum btnFind.

  ON CHOOSE OF btnFind DO: 
    RUN getCustomer (Customer.CustNum:HANDLE, BUFFER Customer). 
    IF NOT ERROR-STATUS:ERROR THEN
      DISPLAY Customer EXCEPT Customer.Comments WITH SIDE-LABELS.
  END.

  ON ENTRY OF Customer.CustNum
    HIDE MESSAGE.
END.
  
WAIT-FOR WINDOW-CLOSE OF CURRENT-WINDOW.  

PROCEDURE getCustomer:
  DEFINE INPUT PARAMETER  hWidget    AS HANDLE.
  DEFINE PARAMETER BUFFER pbCustomer FOR Customer.

  FIND pbCustomer WHERE pbCustomer.CustNum = 
    INTEGER(hWidget:SCREEN-VALUE) NO-LOCK NO-ERROR.

  IF NOT AVAILABLE pbCustomer THEN DO:
    MESSAGE "Customer record not found." VIEW-AS ALERT-BOX.
    RETURN ERROR.
  END. 
END.
