/* r-maxmum.p */

DEFINE VARIABLE cred-lim2 AS DECIMAL NO-UNDO FORMAT ">>,>>9.99".

FOR EACH Customer NO-LOCK:
  cred-lim2 = IF Customer.CreditLimit < 20000 THEN
    Customer.CreditLimit + 10000 ELSE 30000.
  DISPLAY Customer.CreditLimit cred-lim2
    MAXIMUM(cred-lim2, Customer.CreditLimit) 
      LABEL "Maximum of these two values".
END.
