/* r-return.p */

DEFINE VARIABLE ix    AS INTEGER NO-UNDO.
DEFINE VARIABLE n     AS INTEGER NO-UNDO LABEL "N" FORMAT "->9".
DEFINE VARIABLE nfact AS INTEGER NO-UNDO LABEL "N Factorial" 
  FORMAT ">,>>>,>>>,>>9".

REPEAT:
  SET n SPACE(5).
  ASSIGN nfact = n.
  RUN r-fact.p (INPUT-OUTPUT nfact).
  DISPLAY nfact.

  CATCH mae AS Progress.Lang.AppError:
    REPEAT ix = 1 TO mae:NumMessages:
      MESSAGE "Error Number: " mae:GetMessageNum(ix) SKIP
        "Message: " mae:GetMessage(ix) SKIP
        "NumMessage: " ix VIEW-AS alert-box.
    END. 
    MESSAGE "Here is the ReturnValue " mae:ReturnValue VIEW-AS ALERT-BOX. 
  END CATCH.
END. /* REPEAT */
