/* r-select.p */

DEFINE VARIABLE f-name        AS CHARACTER NO-UNDO FORMAT "x(14)".
DEFINE VARIABLE choice        AS CHARACTER NO-UNDO FORMAT "x(50)"
  LABEL "You have selected".
DEFINE VARIABLE list_contents AS CHARACTER NO-UNDO FORMAT "x(200)".
DEFINE VARIABLE dir           AS CHARACTER NO-UNDO FORMAT "x(40)" 
  LABEL "Please enter a directory pathname ".
DEFINE VARIABLE sl            AS CHARACTER NO-UNDO 
  VIEW-AS SELECTION-LIST INNER-CHARS 15 INNER-LINES 10 SORT.

DEFINE FRAME b sl.
DEFINE FRAME c choice.

DEFINE STREAM dirlist.

ENABLE dir WITH FRAME d WITH SIDE-LABELS.
ON RETURN OF dir IN FRAME d DO:
  ASSIGN FRAME d dir.
  INPUT STREAM dirlist FROM OS-DIR (dir).
  IMPORT STREAM dirlist f-name.
  list_contents = f-name.
  REPEAT:   
    IMPORT STREAM dirlist f-name.
    list_contents = list_contents + "," + f-name.
  END.
  INPUT CLOSE.

  sl:LIST-ITEMS IN FRAME b = list_contents.
  ENABLE sl WITH FRAME b NO-LABELS TITLE "Please Select a File" WIDTH 50.
END.

ON VALUE-CHANGED OF sl IN FRAME b DO:
  choice = sl:SCREEN-VALUE.
  DISPLAY choice WITH FRAME c SIDE-LABELS.
END.

WAIT-FOR WINDOW-CLOSE OF CURRENT-WINDOW.
