/* r-set2.p */

FOR EACH Customer:
  DISPLAY Customer.CustNum Customer.Name Customer.CreditLimit.
  SET Customer.Name Customer.CreditLimit
    VALIDATE(Customer.CreditLimit > 0, "Invalid credit limit.")
    HELP "Enter a positive credit-limit.".
  REPEAT:
    CREATE Order.
    Order.CustNum = Customer.CustNum.
    SET Order.OrderNum Order.ShipDate VALIDATE(Order.ShipDate > TODAY,
      "Ship date too early.").
  END.
END.
