/* r-termpg.p */

DEFINE VARIABLE ix AS INTEGER NO-UNDO.

OUTPUT TO TERMINAL PAGED.

FOR EACH Customer NO-LOCK BREAK BY Customer.SalesRep:
  FIND SalesRep OF Customer NO-LOCK.
  FORM HEADER TODAY
    "Customer Listing For " TO 43
    "Page " TO 55 PAGE-NUMBER - ix  TO 58 FORMAT "99"
    (SalesRep.RepName) FORMAT "x(30)" AT 25
    WITH FRAME hdr PAGE-TOP CENTERED.
  VIEW FRAME hdr.
  DISPLAY Customer.CustNum COLUMN-LABEL "Customer!Number"
    Customer.Name LABEL "Name"
    Customer.Phone COLUMN-LABEL "Phone!Number" WITH CENTERED.
  IF LAST-OF(Customer.SalesRep) THEN DO:
    ix = PAGE-NUMBER.
    PAGE.
  END.
END. /* FOR EACH Customer */

OUTPUT CLOSE.
