&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW

/* Temp-Table and Buffer definitions                                    */
DEFINE TEMP-TABLE RowObject
       {"dbin.i"}.


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS vTableWin 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------

  File:

  Description: from viewer.w - Template for SmartDataViewer objects

  Input Parameters:
      <none>

  Output Parameters:
      <none>

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

DEFINE TEMP-TABLE ttBin LIKE BIN
    FIELD oldQty LIKE bin.qty.

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDataViewer
&Scoped-define DB-AWARE no

&Scoped-define ADM-SUPPORTED-LINKS TableIO-Target,Data-Target,Update-Source,GroupAssign-Source,GroupAssign-Target

/* Include file with RowObject temp-table definition */
&Scoped-define DATA-FIELD-DEFS "dbin.i"

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME F-Main

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS RowObject.Qty 
&Scoped-define ENABLED-TABLES RowObject
&Scoped-define FIRST-ENABLED-TABLE RowObject
&Scoped-define DISPLAYED-TABLES RowObject
&Scoped-define FIRST-DISPLAYED-TABLE RowObject
&Scoped-Define ENABLED-OBJECTS btReallocate 
&Scoped-Define DISPLAYED-FIELDS RowObject.WarehouseNum RowObject.Itemnum ~
RowObject.Qty 

/* Custom List Definitions                                              */
/* ADM-ASSIGN-FIELDS,List-2,List-3,List-4,List-5,List-6                 */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Definitions of the field level widgets                               */
DEFINE BUTTON btReallocate 
     LABEL "Reallocate" 
     SIZE 15 BY 1.14.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME F-Main
     RowObject.WarehouseNum AT ROW 1.29 COL 17 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 13.2 BY 1
     RowObject.Itemnum AT ROW 1.29 COL 42 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 13.2 BY 1
     RowObject.Qty AT ROW 1.29 COL 63 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 8.6 BY 1
     btReallocate AT ROW 1.29 COL 78
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY USE-DICT-EXPS 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1 SCROLLABLE 
         DEFAULT-BUTTON btReallocate.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDataViewer
   Data Source: "dbin.w"
   Allow: Basic,DB-Fields
   Frames: 1
   Add Fields to: Neither
   Other Settings: PERSISTENT-ONLY COMPILE
   Temp-Tables and Buffers:
      TABLE: RowObject D "?" ?  
      ADDITIONAL-FIELDS:
          {dbin.i}
      END-FIELDS.
   END-TABLES.
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT."
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW vTableWin ASSIGN
         HEIGHT             = 2.67
         WIDTH              = 105.8.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB vTableWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/viewer.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW vTableWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME F-Main
   NOT-VISIBLE Size-to-Fit                                              */
ASSIGN 
       FRAME F-Main:SCROLLABLE       = FALSE
       FRAME F-Main:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN RowObject.Itemnum IN FRAME F-Main
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN RowObject.WarehouseNum IN FRAME F-Main
   NO-ENABLE                                                            */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME F-Main
/* Query rebuild information for FRAME F-Main
     _Options          = "NO-LOCK"
     _Query            is NOT OPENED
*/  /* FRAME F-Main */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME btReallocate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btReallocate vTableWin
ON CHOOSE OF btReallocate IN FRAME F-Main /* Reallocate */
DO:
  RUN reallocate(INPUT RowObject.WarehouseNum:SCREEN-VALUE,
                INPUT RowObject.Itemnum:SCREEN-VALUE,       
                INPUT RowObject.Qty:SCREEN-VALUE).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK vTableWin 


/* ***************************  Main Block  *************************** */

  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          
    RUN initializeObject.
  &ENDIF         
  
  /************************ INTERNAL PROCEDURES ********************/

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI vTableWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME F-Main.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject vTableWin 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

RUN SUPER.
    
RowObject.Qty:SENSITIVE IN FRAME {&FRAME-NAME} = YES.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE reallocate vTableWin 
PROCEDURE reallocate :
/*------------------------------------------------------------------------------
  Purpose: Allows the Restocking of one warehouse's items by moving a percentage
            of the items from other warehouses.    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

DEFINE INPUT PARAMETER  iWarehouseNum   AS INTEGER  NO-UNDO.
DEFINE INPUT PARAMETER  iItemNum        AS INTEGER  NO-UNDO.
DEFINE INPUT PARAMETER  iNewQty         AS INTEGER  NO-UNDO.

DEFINE VARIABLE         iOldQty         AS INTEGER  NO-UNDO INIT 0.
DEFINE VARIABLE         iCount          AS INTEGER  NO-UNDO INIT 0.
DEFINE VARIABLE         iValue          AS INTEGER  NO-UNDO INIT 0. 
DEFINE VARIABLE         iBase           AS INTEGER  NO-UNDO INIT 0.
DEFINE VARIABLE         iRemainder      AS INTEGER  NO-UNDO INIT 0.  
DEFINE VARIABLE         lContinue       AS LOGICAL  NO-UNDO.   
DEFINE VARIABLE         hBinDataSource  AS HANDLE   NO-UNDO.

EMPTY TEMP-TABLE ttBin.  /* Make sure to clear the Temp-table */

FOR EACH bin WHERE bin.ItemNum = iItemNum NO-LOCK:
    
    CREATE ttBin.
    BUFFER-COPY bin TO ttBin.
    ttBin.oldqty = bin.qty.
    IF bin.WareHouseNum = iWarehouseNum THEN iOldQty = bin.Qty.
    ELSE iCount = iCount + 1.        /* Number of Warehouses containing item */
END.

iValue = iOldQty - iNewQty.  /* Return positive if adding, negative if subtracting */

iBase = TRUNCATE(iValue / iCount, 0).  /* Get Base Count Items */
IF iValue < 0 THEN  
    iRemainder = -(iValue) MODULO iCount.      /* Get Extra Items */
ELSE
    iRemainder = iValue MODULO iCount.
IF iBase < 0 THEN iRemainder = -(iRemainder).

FOR EACH ttBin:
    IF ttBin.WarehouseNum = iWarehouseNum THEN DO:
        ttBin.Qty = ttBin.Qty - iValue.
    END.
    ELSE DO:
        IF iRemainder NE 0 THEN DO:
            IF iBase < 0 THEN DO:
                ASSIGN
                    ttBin.Qty = ttBin.Qty + iBase - 1
                    iRemainder = iRemainder + 1.
            END.
            ELSE DO:
                ASSIGN 
                    ttBin.Qty = ttBin.Qty + iBase + 1
                    iRemainder = iRemainder - 1.
            END.  
        END.
        ELSE DO: 
            ttBin.Qty = ttBin.Qty + iBase.  
        END.
    END.
END.

RUN gallocate.w (INPUT TABLE ttBin, OUTPUT lContinue). 

IF lContinue THEN DO:
    FOR EACH ttBin:
        FIND bin where bin.warehousenum = ttbin.warehousenum AND
            bin.itemnum = ttbin.itemnum NO-ERROR.
        IF AVAILABLE bin THEN bin.qty = ttbin.qty.
    END.
END.

{get DataSource hBinDataSource}.

{fn openQuery hBinDataSource}.       
        


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

