/* pi-tfx-read-2.p */
/* Verifies XML Schema against a static temp-table. */

{pi-tfx-parameterVarDefs.i}
    
DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.

DEFINE TEMP-TABLE ttCust 
  FIELD CustNum LIKE Customer.CustNum
  FIELD Name LIKE Customer.Name FORMAT "X(30)".
    
ASSIGN
  cSourceType             = "FILE"
  cFile                   = "ttCust.xsd"
  lOverrideDefaultMapping = ?
  cFieldTypeMapping       = ?
  cVerifySchemaMode       = "STRICT".

DISPLAY "Reading XML Schema..." SKIP.
    
returnValue = TEMP-TABLE ttCust:READ-XMLSCHEMA(cSourceType, cFile,
                                               lOverrideDefaultMapping,
                                               cFieldTypeMapping, 
                                               cVerifySchemaMode).

IF returnValue THEN 
  DISPLAY "Success: Temp-table definition verified against XML Schema.".
