/* pi-tfx-write-3.p */
/* Populates a temp-table with a subset of Customer records and writes it 
   to an XML file. */
  
{pi-tfx-parameterVarDefs.i}
{pi-tfx-writeSetup-3.i}
    
DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.

FOR EACH Customer WHERE CustNum < 4:
  CREATE ttCust.
  BUFFER-COPY Customer TO ttCust.
END.

ASSIGN
  cTargetType     = "FILE"
  cFile           = "ttCust.xml" 
  lFormatted      = TRUE
  cEncoding       = ?
  cSchemaLocation = ?
  lWriteSchema    = FALSE
  lMinSchema      = FALSE.
 
returnValue = TEMP-TABLE ttCust:WRITE-XML(cTargetType, cFile, lFormatted,
                                          cEncoding, cSchemaLocation, 
                                          lWriteSchema, lMinSchema).
