/*------------------------------------------------------------------------
    File        : purchaseOrderForm
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : 
    Created     : Wed Jun 25 15:03:40 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Progress.Windows.Form.
USING openedge.tutorial.ui.*.
USING openedge.tutorial.services.*.


CLASS openedge.tutorial.ui.purchaseOrderForm INHERITS Form IMPLEMENTS IUpdatable  : 
    
    DEF PRIVATE VAR fServiceAdapter AS openedge.tutorial.services.ServiceAdapter NO-UNDO. 
    DEF PRIVATE VAR fRecordState AS CHARACTER NO-UNDO.
	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.

	DEFINE PRIVATE VARIABLE bindingSource1 AS Progress.Data.BindingSource NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraGroupBox1 AS Infragistics.Win.Misc.UltraGroupBox NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraLabel1 AS Infragistics.Win.Misc.UltraLabel NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraNumericEditor1 AS Infragistics.Win.UltraWinEditors.UltraNumericEditor NO-UNDO.

	DEFINE PRIVATE VARIABLE ultraLabel5 AS Infragistics.Win.Misc.UltraLabel NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraLabel4 AS Infragistics.Win.Misc.UltraLabel NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraDateTimeEditor2 AS Infragistics.Win.UltraWinEditors.UltraDateTimeEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraDateTimeEditor1 AS Infragistics.Win.UltraWinEditors.UltraDateTimeEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraLabel3 AS Infragistics.Win.Misc.UltraLabel NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraNumericEditor2 AS Infragistics.Win.UltraWinEditors.UltraNumericEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraLabel2 AS Infragistics.Win.Misc.UltraLabel NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraTextEditor1 AS Infragistics.Win.UltraWinEditors.UltraTextEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE panel1 AS System.Windows.Forms.Panel NO-UNDO.

	DEFINE PRIVATE VARIABLE btnAdd AS Infragistics.Win.Misc.UltraButton NO-UNDO.
	DEFINE PRIVATE VARIABLE btnLast AS Infragistics.Win.Misc.UltraButton NO-UNDO.
	DEFINE PRIVATE VARIABLE btnNext AS Infragistics.Win.Misc.UltraButton NO-UNDO.
	DEFINE PRIVATE VARIABLE btnPrev AS Infragistics.Win.Misc.UltraButton NO-UNDO.
	DEFINE PRIVATE VARIABLE btnFirst AS Infragistics.Win.Misc.UltraButton NO-UNDO.

	DEFINE PRIVATE VARIABLE btnCancel AS Infragistics.Win.Misc.UltraButton NO-UNDO.
	DEFINE PRIVATE VARIABLE btnSave AS Infragistics.Win.Misc.UltraButton NO-UNDO.
	DEFINE PRIVATE VARIABLE btnDelete AS Infragistics.Win.Misc.UltraButton NO-UNDO.

    CONSTRUCTOR PUBLIC  PurchaseOrderForm (  ):
		
		SUPER().
		fServiceAdapter = NEW ServiceAdapter("PurchOrder").
		InitializeComponent ( ).
        OpenQuery().
	END CONSTRUCTOR.	





	METHOD PRIVATE VOID InitializeComponent ( ):

/* 		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

		We strongly suggest that the contents of this method only be modified using the
		Visual Designer to avoid any incompatible modifications.

		Modifying the contents of this method using a code editor will invalidate any support for this file. */

		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE tableDesc1 AS Progress.Data.TableDesc NO-UNDO.
		tableDesc1 = NEW Progress.Data.TableDesc("ePurchaseOrder").
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE tableDesc2 AS Progress.Data.TableDesc NO-UNDO.
		tableDesc2 = NEW Progress.Data.TableDesc("ePOLine").
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE tableDesc3 AS Progress.Data.TableDesc NO-UNDO.
		tableDesc3 = NEW Progress.Data.TableDesc("eItem").
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE tableDesc4 AS Progress.Data.TableDesc NO-UNDO.
		tableDesc4 = NEW Progress.Data.TableDesc("eSupplier").
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE appearance5 AS Infragistics.Win.Appearance NO-UNDO.
		appearance5 = NEW Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE appearance4 AS Infragistics.Win.Appearance NO-UNDO.
		appearance4 = NEW Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE appearance3 AS Infragistics.Win.Appearance NO-UNDO.
		appearance3 = NEW Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE appearance2 AS Infragistics.Win.Appearance NO-UNDO.
		appearance2 = NEW Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE appearance1 AS Infragistics.Win.Appearance NO-UNDO.
		appearance1 = NEW Infragistics.Win.Appearance().
		THIS-OBJECT:bindingSource1 = NEW Progress.Data.BindingSource().
		THIS-OBJECT:ultraGroupBox1 = NEW Infragistics.Win.Misc.UltraGroupBox().
		THIS-OBJECT:ultraLabel5 = NEW Infragistics.Win.Misc.UltraLabel().
		THIS-OBJECT:ultraLabel4 = NEW Infragistics.Win.Misc.UltraLabel().
		THIS-OBJECT:ultraDateTimeEditor2 = NEW Infragistics.Win.UltraWinEditors.UltraDateTimeEditor().
		THIS-OBJECT:ultraDateTimeEditor1 = NEW Infragistics.Win.UltraWinEditors.UltraDateTimeEditor().
		THIS-OBJECT:ultraLabel3 = NEW Infragistics.Win.Misc.UltraLabel().
		THIS-OBJECT:ultraNumericEditor2 = NEW Infragistics.Win.UltraWinEditors.UltraNumericEditor().
		THIS-OBJECT:ultraLabel2 = NEW Infragistics.Win.Misc.UltraLabel().
		THIS-OBJECT:ultraTextEditor1 = NEW Infragistics.Win.UltraWinEditors.UltraTextEditor().
		THIS-OBJECT:ultraLabel1 = NEW Infragistics.Win.Misc.UltraLabel().
		THIS-OBJECT:ultraNumericEditor1 = NEW Infragistics.Win.UltraWinEditors.UltraNumericEditor().
		THIS-OBJECT:panel1 = NEW System.Windows.Forms.Panel().
		THIS-OBJECT:btnCancel = NEW Infragistics.Win.Misc.UltraButton().
		THIS-OBJECT:btnSave = NEW Infragistics.Win.Misc.UltraButton().
		THIS-OBJECT:btnDelete = NEW Infragistics.Win.Misc.UltraButton().
		THIS-OBJECT:btnAdd = NEW Infragistics.Win.Misc.UltraButton().
		THIS-OBJECT:btnLast = NEW Infragistics.Win.Misc.UltraButton().
		THIS-OBJECT:btnNext = NEW Infragistics.Win.Misc.UltraButton().
		THIS-OBJECT:btnPrev = NEW Infragistics.Win.Misc.UltraButton().
		THIS-OBJECT:btnFirst = NEW Infragistics.Win.Misc.UltraButton().
		CAST(THIS-OBJECT:bindingSource1, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:ultraGroupBox1, System.ComponentModel.ISupportInitialize):BeginInit().
		THIS-OBJECT:ultraGroupBox1:SuspendLayout().
		CAST(THIS-OBJECT:ultraDateTimeEditor2, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:ultraDateTimeEditor1, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:ultraNumericEditor2, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:ultraTextEditor1, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:ultraNumericEditor1, System.ComponentModel.ISupportInitialize):BeginInit().
		THIS-OBJECT:panel1:SuspendLayout().
		THIS-OBJECT:SuspendLayout().
		/*  */
		/* bindingSource1 */
		/*  */
		THIS-OBJECT:bindingSource1:AllowEdit = FALSE.
		THIS-OBJECT:bindingSource1:AllowNew = FALSE.
		THIS-OBJECT:bindingSource1:AllowRemove = FALSE.
		THIS-OBJECT:bindingSource1:Position = 0.
		tableDesc3:ChildTables = ?.
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar0 AS Progress.Data.ColumnPropDesc EXTENT 14 NO-UNDO.
		arrayvar0[1] = NEW Progress.Data.ColumnPropDesc("Itemnum", "Item Num", Progress.Data.DataType:INTEGER).
		arrayvar0[2] = NEW Progress.Data.ColumnPropDesc("ItemName", "Item Name", Progress.Data.DataType:CHARACTER).
		arrayvar0[3] = NEW Progress.Data.ColumnPropDesc("Price", "Price", Progress.Data.DataType:DECIMAL).
		arrayvar0[4] = NEW Progress.Data.ColumnPropDesc("Onhand", "On Hand", Progress.Data.DataType:INTEGER).
		arrayvar0[5] = NEW Progress.Data.ColumnPropDesc("Allocated", "Allocated", Progress.Data.DataType:INTEGER).
		arrayvar0[6] = NEW Progress.Data.ColumnPropDesc("ReOrder", "Re Order", Progress.Data.DataType:INTEGER).
		arrayvar0[7] = NEW Progress.Data.ColumnPropDesc("OnOrder", "On Order", Progress.Data.DataType:INTEGER).
		arrayvar0[8] = NEW Progress.Data.ColumnPropDesc("CatPage", "Cat Page", Progress.Data.DataType:INTEGER).
		arrayvar0[9] = NEW Progress.Data.ColumnPropDesc("CatDescription", "Cat-Description", Progress.Data.DataType:CHARACTER).
		arrayvar0[10] = NEW Progress.Data.ColumnPropDesc("Category1", "Category1", Progress.Data.DataType:CHARACTER).
		arrayvar0[11] = NEW Progress.Data.ColumnPropDesc("Category2", "Category2", Progress.Data.DataType:CHARACTER).
		arrayvar0[12] = NEW Progress.Data.ColumnPropDesc("Special", "Special", Progress.Data.DataType:CHARACTER).
		arrayvar0[13] = NEW Progress.Data.ColumnPropDesc("Weight", "Weight", Progress.Data.DataType:DECIMAL).
		arrayvar0[14] = NEW Progress.Data.ColumnPropDesc("Minqty", "Min Qty", Progress.Data.DataType:INTEGER).
		tableDesc3:Columns = arrayvar0.
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar1 AS Progress.Data.TableDesc EXTENT 1 NO-UNDO.
		arrayvar1[1] = tableDesc3.
		tableDesc2:ChildTables = arrayvar1.
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar2 AS Progress.Data.ColumnPropDesc EXTENT 8 NO-UNDO.
		arrayvar2[1] = NEW Progress.Data.ColumnPropDesc("Linenum", "Line Num", Progress.Data.DataType:INTEGER).
		arrayvar2[2] = NEW Progress.Data.ColumnPropDesc("Itemnum", "Item Num", Progress.Data.DataType:INTEGER).
		arrayvar2[3] = NEW Progress.Data.ColumnPropDesc("Price", "Price", Progress.Data.DataType:DECIMAL).
		arrayvar2[4] = NEW Progress.Data.ColumnPropDesc("Qty", "Qty", Progress.Data.DataType:INTEGER).
		arrayvar2[5] = NEW Progress.Data.ColumnPropDesc("Discount", "Discount", Progress.Data.DataType:INTEGER).
		arrayvar2[6] = NEW Progress.Data.ColumnPropDesc("ExtendedPrice", "Extended Price", Progress.Data.DataType:DECIMAL).
		arrayvar2[7] = NEW Progress.Data.ColumnPropDesc("PONum", "Order Num", Progress.Data.DataType:INTEGER).
		arrayvar2[8] = NEW Progress.Data.ColumnPropDesc("POLineStatus", "PO Line Status", Progress.Data.DataType:CHARACTER).
		tableDesc2:Columns = arrayvar2.
		tableDesc4:ChildTables = ?.
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar3 AS Progress.Data.ColumnPropDesc EXTENT 14 NO-UNDO.
		arrayvar3[1] = NEW Progress.Data.ColumnPropDesc("SupplierIDNum", "Supplier ID", Progress.Data.DataType:INTEGER).
		arrayvar3[2] = NEW Progress.Data.ColumnPropDesc("Name", "Name", Progress.Data.DataType:CHARACTER).
		arrayvar3[3] = NEW Progress.Data.ColumnPropDesc("Address", "Address", Progress.Data.DataType:CHARACTER).
		arrayvar3[4] = NEW Progress.Data.ColumnPropDesc("Address2", "Address2", Progress.Data.DataType:CHARACTER).
		arrayvar3[5] = NEW Progress.Data.ColumnPropDesc("City", "City", Progress.Data.DataType:CHARACTER).
		arrayvar3[6] = NEW Progress.Data.ColumnPropDesc("State", "State", Progress.Data.DataType:CHARACTER).
		arrayvar3[7] = NEW Progress.Data.ColumnPropDesc("PostalCode", "ZipCode", Progress.Data.DataType:CHARACTER).
		arrayvar3[8] = NEW Progress.Data.ColumnPropDesc("Country", "Country", Progress.Data.DataType:CHARACTER).
		arrayvar3[9] = NEW Progress.Data.ColumnPropDesc("Phone", "Phone", Progress.Data.DataType:CHARACTER).
		arrayvar3[10] = NEW Progress.Data.ColumnPropDesc("Comments", "Comments", Progress.Data.DataType:CHARACTER).
		arrayvar3[11] = NEW Progress.Data.ColumnPropDesc("Password", "Password", Progress.Data.DataType:CHARACTER).
		arrayvar3[12] = NEW Progress.Data.ColumnPropDesc("LoginDate", "Login Date", Progress.Data.DataType:DATE).
		arrayvar3[13] = NEW Progress.Data.ColumnPropDesc("ShipAmount", "Ship Amount", Progress.Data.DataType:INTEGER).
		arrayvar3[14] = NEW Progress.Data.ColumnPropDesc("Discount", "Discount", Progress.Data.DataType:INTEGER).
		tableDesc4:Columns = arrayvar3.
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar4 AS Progress.Data.TableDesc EXTENT 2 NO-UNDO.
		arrayvar4[1] = tableDesc2.
		arrayvar4[2] = tableDesc4.
		tableDesc1:ChildTables = arrayvar4.
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar5 AS Progress.Data.ColumnPropDesc EXTENT 5 NO-UNDO.
		arrayvar5[1] = NEW Progress.Data.ColumnPropDesc("PONum", "PO Num", Progress.Data.DataType:INTEGER).
		arrayvar5[2] = NEW Progress.Data.ColumnPropDesc("DateEntered", "Date Entered", Progress.Data.DataType:DATE).
		arrayvar5[3] = NEW Progress.Data.ColumnPropDesc("SupplierIDNum", "Supplier ID", Progress.Data.DataType:INTEGER).
		arrayvar5[4] = NEW Progress.Data.ColumnPropDesc("ReceiveDate", "Date Received", Progress.Data.DataType:DATE).
		arrayvar5[5] = NEW Progress.Data.ColumnPropDesc("POStatus", "PO Status", Progress.Data.DataType:CHARACTER).
		tableDesc1:Columns = arrayvar5.
		THIS-OBJECT:bindingSource1:TableSchema = tableDesc1.
		THIS-OBJECT:bindingSource1:PositionChanged:SUBSCRIBE(THIS-OBJECT:onPositionChanged).
		/*  */
		/* ultraGroupBox1 */
		/*  */
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraLabel5).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraLabel4).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraDateTimeEditor2).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraDateTimeEditor1).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraLabel3).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraNumericEditor2).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraLabel2).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraTextEditor1).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraLabel1).
		THIS-OBJECT:ultraGroupBox1:Controls:Add(THIS-OBJECT:ultraNumericEditor1).
		THIS-OBJECT:ultraGroupBox1:HeaderPosition = Infragistics.Win.Misc.GroupBoxHeaderPosition:TopInsideBorder.
		THIS-OBJECT:ultraGroupBox1:Location = NEW System.Drawing.Point(12, 12).
		THIS-OBJECT:ultraGroupBox1:Name = "ultraGroupBox1".
		THIS-OBJECT:ultraGroupBox1:Size = NEW System.Drawing.Size(268, 182).
		THIS-OBJECT:ultraGroupBox1:TabIndex = 0.
		THIS-OBJECT:ultraGroupBox1:Text = "Details".
		/*  */
		/* ultraLabel5 */
		/*  */
		appearance5:TextVAlignAsString = "Middle".
		THIS-OBJECT:ultraLabel5:Appearance = appearance5.
		THIS-OBJECT:ultraLabel5:Location = NEW System.Drawing.Point(55, 131).
		THIS-OBJECT:ultraLabel5:Name = "ultraLabel5".
		THIS-OBJECT:ultraLabel5:Size = NEW System.Drawing.Size(100, 23).
		THIS-OBJECT:ultraLabel5:TabIndex = 9.
		THIS-OBJECT:ultraLabel5:Text = "Date Received".
		/*  */
		/* ultraLabel4 */
		/*  */
		appearance4:TextVAlignAsString = "Middle".
		THIS-OBJECT:ultraLabel4:Appearance = appearance4.
		THIS-OBJECT:ultraLabel4:Location = NEW System.Drawing.Point(54, 104).
		THIS-OBJECT:ultraLabel4:Name = "ultraLabel4".
		THIS-OBJECT:ultraLabel4:Size = NEW System.Drawing.Size(100, 23).
		THIS-OBJECT:ultraLabel4:TabIndex = 8.
		THIS-OBJECT:ultraLabel4:Text = "Date Entered".
		/*  */
		/* ultraDateTimeEditor2 */
		/*  */
		THIS-OBJECT:ultraDateTimeEditor2:DataBindings:Add(NEW System.Windows.Forms.Binding("Text", THIS-OBJECT:bindingSource1, "ReceiveDate", TRUE)).
		THIS-OBJECT:ultraDateTimeEditor2:Location = NEW System.Drawing.Point(161, 134).
		THIS-OBJECT:ultraDateTimeEditor2:MaskInput = "~{date~}".
		THIS-OBJECT:ultraDateTimeEditor2:Name = "ultraDateTimeEditor2".
		THIS-OBJECT:ultraDateTimeEditor2:Size = NEW System.Drawing.Size(100, 21).
		THIS-OBJECT:ultraDateTimeEditor2:TabIndex = 7.
		/*  */
		/* ultraDateTimeEditor1 */
		/*  */
		THIS-OBJECT:ultraDateTimeEditor1:DataBindings:Add(NEW System.Windows.Forms.Binding("Text", THIS-OBJECT:bindingSource1, "DateEntered", TRUE)).
		THIS-OBJECT:ultraDateTimeEditor1:Location = NEW System.Drawing.Point(161, 107).
		THIS-OBJECT:ultraDateTimeEditor1:MaskInput = "~{date~}".
		THIS-OBJECT:ultraDateTimeEditor1:Name = "ultraDateTimeEditor1".
		THIS-OBJECT:ultraDateTimeEditor1:Size = NEW System.Drawing.Size(101, 21).
		THIS-OBJECT:ultraDateTimeEditor1:TabIndex = 6.
		/*  */
		/* ultraLabel3 */
		/*  */
		appearance3:TextVAlignAsString = "Middle".
		THIS-OBJECT:ultraLabel3:Appearance = appearance3.
		THIS-OBJECT:ultraLabel3:Location = NEW System.Drawing.Point(55, 77).
		THIS-OBJECT:ultraLabel3:Name = "ultraLabel3".
		THIS-OBJECT:ultraLabel3:Size = NEW System.Drawing.Size(100, 23).
		THIS-OBJECT:ultraLabel3:TabIndex = 5.
		THIS-OBJECT:ultraLabel3:Text = "Supplier ID".
		/*  */
		/* ultraNumericEditor2 */
		/*  */
		THIS-OBJECT:ultraNumericEditor2:DataBindings:Add(NEW System.Windows.Forms.Binding("Text", THIS-OBJECT:bindingSource1, "SupplierIDNum", TRUE)).
		THIS-OBJECT:ultraNumericEditor2:Location = NEW System.Drawing.Point(161, 80).
		THIS-OBJECT:ultraNumericEditor2:MaskInput = "nnnnnnnnn".
		THIS-OBJECT:ultraNumericEditor2:Name = "ultraNumericEditor2".
		THIS-OBJECT:ultraNumericEditor2:Size = NEW System.Drawing.Size(100, 21).
		THIS-OBJECT:ultraNumericEditor2:TabIndex = 4.
		/*  */
		/* ultraLabel2 */
		/*  */
		appearance2:TextVAlignAsString = "Middle".
		THIS-OBJECT:ultraLabel2:Appearance = appearance2.
		THIS-OBJECT:ultraLabel2:Location = NEW System.Drawing.Point(56, 51).
		THIS-OBJECT:ultraLabel2:Name = "ultraLabel2".
		THIS-OBJECT:ultraLabel2:Size = NEW System.Drawing.Size(100, 23).
		THIS-OBJECT:ultraLabel2:TabIndex = 3.
		THIS-OBJECT:ultraLabel2:Text = "Order Status".
		/*  */
		/* ultraTextEditor1 */
		/*  */
		THIS-OBJECT:ultraTextEditor1:DataBindings:Add(NEW System.Windows.Forms.Binding("Text", THIS-OBJECT:bindingSource1, "POStatus", TRUE)).
		THIS-OBJECT:ultraTextEditor1:Location = NEW System.Drawing.Point(162, 52).
		THIS-OBJECT:ultraTextEditor1:Name = "ultraTextEditor1".
		THIS-OBJECT:ultraTextEditor1:Size = NEW System.Drawing.Size(100, 21).
		THIS-OBJECT:ultraTextEditor1:TabIndex = 2.
		THIS-OBJECT:ultraTextEditor1:Text = "ultraTextEditor1".
		/*  */
		/* ultraLabel1 */
		/*  */
		appearance1:TextVAlignAsString = "Middle".
		THIS-OBJECT:ultraLabel1:Appearance = appearance1.
		THIS-OBJECT:ultraLabel1:Location = NEW System.Drawing.Point(56, 24).
		THIS-OBJECT:ultraLabel1:Name = "ultraLabel1".
		THIS-OBJECT:ultraLabel1:Size = NEW System.Drawing.Size(100, 23).
		THIS-OBJECT:ultraLabel1:TabIndex = 1.
		THIS-OBJECT:ultraLabel1:Text = "PO Number".
		/*  */
		/* ultraNumericEditor1 */
		/*  */
		THIS-OBJECT:ultraNumericEditor1:DataBindings:Add(NEW System.Windows.Forms.Binding("Text", THIS-OBJECT:bindingSource1, "PONum", TRUE)).
		THIS-OBJECT:ultraNumericEditor1:Location = NEW System.Drawing.Point(162, 25).
		THIS-OBJECT:ultraNumericEditor1:MaskDisplayMode = Infragistics.Win.UltraWinMaskedEdit.MaskMode:Raw.
		THIS-OBJECT:ultraNumericEditor1:MaskInput = "nnnnnnnnn".
		THIS-OBJECT:ultraNumericEditor1:Name = "ultraNumericEditor1".
		THIS-OBJECT:ultraNumericEditor1:Size = NEW System.Drawing.Size(100, 21).
		THIS-OBJECT:ultraNumericEditor1:TabIndex = 0.
		/*  */
		/* panel1 */
		/*  */
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnCancel).
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnSave).
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnDelete).
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnAdd).
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnLast).
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnNext).
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnPrev).
		THIS-OBJECT:panel1:Controls:Add(THIS-OBJECT:btnFirst).
		THIS-OBJECT:panel1:Location = NEW System.Drawing.Point(12, 200).
		THIS-OBJECT:panel1:Name = "panel1".
		THIS-OBJECT:panel1:Size = NEW System.Drawing.Size(268, 209).
		THIS-OBJECT:panel1:TabIndex = 1.
		/*  */
		/* btnCancel */
		/*  */
		THIS-OBJECT:btnCancel:Location = NEW System.Drawing.Point(162, 168).
		THIS-OBJECT:btnCancel:Name = "btnCancel".
		THIS-OBJECT:btnCancel:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnCancel:TabIndex = 7.
		THIS-OBJECT:btnCancel:Text = "Cancel".
		THIS-OBJECT:btnCancel:Click:SUBSCRIBE(THIS-OBJECT:btnCancel_Click).
		/*  */
		/* btnSave */
		/*  */
		THIS-OBJECT:btnSave:Location = NEW System.Drawing.Point(162, 119).
		THIS-OBJECT:btnSave:Name = "btnSave".
		THIS-OBJECT:btnSave:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnSave:TabIndex = 6.
		THIS-OBJECT:btnSave:Text = "Save".
		THIS-OBJECT:btnSave:Click:SUBSCRIBE(THIS-OBJECT:btnSave_Click).
		/*  */
		/* btnDelete */
		/*  */
		THIS-OBJECT:btnDelete:Location = NEW System.Drawing.Point(162, 70).
		THIS-OBJECT:btnDelete:Name = "btnDelete".
		THIS-OBJECT:btnDelete:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnDelete:TabIndex = 5.
		THIS-OBJECT:btnDelete:Text = "Delete".
		THIS-OBJECT:btnDelete:Click:SUBSCRIBE(THIS-OBJECT:btnDelete_Click).
		/*  */
		/* btnAdd */
		/*  */
		THIS-OBJECT:btnAdd:Location = NEW System.Drawing.Point(162, 21).
		THIS-OBJECT:btnAdd:Name = "btnAdd".
		THIS-OBJECT:btnAdd:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnAdd:TabIndex = 4.
		THIS-OBJECT:btnAdd:Text = "Add".
		THIS-OBJECT:btnAdd:Click:SUBSCRIBE(THIS-OBJECT:btnAdd_Click).
		/*  */
		/* btnLast */
		/*  */
		THIS-OBJECT:btnLast:Location = NEW System.Drawing.Point(54, 168).
		THIS-OBJECT:btnLast:Name = "btnLast".
		THIS-OBJECT:btnLast:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnLast:TabIndex = 3.
		THIS-OBJECT:btnLast:Text = "Last".
		THIS-OBJECT:btnLast:Click:SUBSCRIBE(THIS-OBJECT:btnLast_Click).
		/*  */
		/* btnNext */
		/*  */
		THIS-OBJECT:btnNext:Location = NEW System.Drawing.Point(54, 119).
		THIS-OBJECT:btnNext:Name = "btnNext".
		THIS-OBJECT:btnNext:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnNext:TabIndex = 2.
		THIS-OBJECT:btnNext:Text = "Next".
		THIS-OBJECT:btnNext:Click:SUBSCRIBE(THIS-OBJECT:btnNext_Click).
		/*  */
		/* btnPrev */
		/*  */
		THIS-OBJECT:btnPrev:Location = NEW System.Drawing.Point(54, 70).
		THIS-OBJECT:btnPrev:Name = "btnPrev".
		THIS-OBJECT:btnPrev:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnPrev:TabIndex = 1.
		THIS-OBJECT:btnPrev:Text = "Previous".
		THIS-OBJECT:btnPrev:Click:SUBSCRIBE(THIS-OBJECT:btnPrev_Click).
		/*  */
		/* btnFirst */
		/*  */
		THIS-OBJECT:btnFirst:Location = NEW System.Drawing.Point(54, 21).
		THIS-OBJECT:btnFirst:Name = "btnFirst".
		THIS-OBJECT:btnFirst:Size = NEW System.Drawing.Size(75, 23).
		THIS-OBJECT:btnFirst:TabIndex = 0.
		THIS-OBJECT:btnFirst:Text = "First".
		THIS-OBJECT:btnFirst:Click:SUBSCRIBE(THIS-OBJECT:btnFirst_Click).
		/*  */
		/* purchaseOrderForm */
		/*  */
		THIS-OBJECT:ClientSize = NEW System.Drawing.Size(292, 436).
		THIS-OBJECT:Controls:Add(THIS-OBJECT:panel1).
		THIS-OBJECT:Controls:Add(THIS-OBJECT:ultraGroupBox1).
		THIS-OBJECT:Name = "purchaseOrderForm".
		THIS-OBJECT:Text = "Purchase Order".
		CAST(THIS-OBJECT:bindingSource1, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:ultraGroupBox1, System.ComponentModel.ISupportInitialize):EndInit().
		THIS-OBJECT:ultraGroupBox1:ResumeLayout(FALSE).
		THIS-OBJECT:ultraGroupBox1:PerformLayout().
		CAST(THIS-OBJECT:ultraDateTimeEditor2, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:ultraDateTimeEditor1, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:ultraNumericEditor2, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:ultraTextEditor1, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:ultraNumericEditor1, System.ComponentModel.ISupportInitialize):EndInit().
		THIS-OBJECT:panel1:ResumeLayout(FALSE).
		THIS-OBJECT:ResumeLayout(FALSE).

    END METHOD.

     METHOD PUBLIC VOID AddRecord():
        fServiceAdapter:AddRecord(bindingSource1:Handle:get-buffer-handle('ePurchaseOrder')).
        fRecordState = 'ADD':u.
        btnSave:Enabled = TRUE.
        btnCancel:Enabled = TRUE.
    END METHOD.

    METHOD PUBLIC VOID DeleteRecord():
        fServiceAdapter:RemoveRecord(bindingSource1:Handle:get-buffer-handle('ePurchaseOrder')).
        fServiceAdapter:SaveData().
        bindingSource1:RefreshAll().        
    END METHOD.

    METHOD PUBLIC VOID SaveRecord():
        IF fRecordState NE '':u OR bindingSource1:RowModified THEN
        DO:
            IF bindingSource1:RowModified THEN
                bindingSource1:Assign().
                
            fServiceAdapter:SaveData().
            btnSave:Enabled = NO.
            btnCancel:Enabled = NO.
        END.        
    END METHOD.

    METHOD PUBLIC VOID CancelUpdate():
	    fRecordState = '':u.
	    fServiceAdapter:CancelUpdate(bindingSource1:Handle:get-buffer-handle('ePurchaseOrder')).
	    bindingSource1:RefreshAll().
	    btnSave:Enabled = NO.
	    btnCancel:Enabled = NO.        
    END METHOD.

	METHOD PRIVATE  VOID OnPositionChanged (  sender AS System.Object,  e AS System.EventArgs ):
		DEF VAR pbs AS Progress.Data.BindingSource NO-UNDO.
		
	    pbs = cast(sender, Progress.Data.BindingSource).
	    btnPrev:Enabled = pbs:Position GT 0 .    /*Prev*/
	    btnFirst:Enabled = btnPrev:enabled.
	    btnNext:Enabled = pbs:Position LT (pbs:Count - 1).    /*Next*/
	    btnLast:Enabled = btnNext:Enabled.
	END METHOD.

    METHOD PRIVATE  VOID btnFirst_Click (  sender AS System.Object,  e AS System.EventArgs ):
	    bindingSource1:Position = 0.
	END METHOD.

	METHOD PRIVATE  VOID btnNext_Click (  sender AS System.Object,  e AS System.EventArgs ):
		bindingSource1:Position = bindingSource1:Position + 1.
	END METHOD. 

	METHOD PRIVATE  VOID btnPrev_Click (  sender AS System.Object,  e AS System.EventArgs ):
		bindingSource1:Position = bindingSource1:Position - 1.
	END METHOD.

	METHOD PRIVATE  VOID btnLast_Click (  sender AS System.Object,  e AS System.EventArgs ):
		bindingSource1:Position = bindingSource1:Count - 1.
	END METHOD.

	METHOD PRIVATE  VOID btnSave_Click (  sender AS System.Object,  e AS System.EventArgs ):
	    THIS-OBJECT:SaveRecord().
	END METHOD.

	METHOD PRIVATE  VOID btnAdd_Click (  sender AS System.Object,  e AS System.EventArgs ):
	    THIS-OBJECT:AddRecord().
	END METHOD.

	METHOD PRIVATE  VOID btnDelete_Click (  sender AS System.Object,  e AS System.EventArgs ):
	    THIS-OBJECT:DeleteRecord().
	END METHOD.

	METHOD PRIVATE  VOID btnCancel_Click (  sender AS System.Object,  e AS System.EventArgs ):
	    THIS-OBJECT:CancelUpdate().
	END METHOD.
	
	METHOD PRIVATE VOID OpenQuery():
        bindingSource1:handle = fServiceAdapter:GetDatasetHandle().
        
        btnFirst:Enabled = NO.   /*First*/
        btnPrev:Enabled = NO.    /*Prev*/
		btnNext:Enabled = YES.    /*Next*/
		btnLast:Enabled = YES.    /*Last*/
		btnSave:Enabled = FALSE.
		btnCancel:Enabled = FALSE.
    END METHOD.    /* openQuery */ 
	
	METHOD PRIVATE VOID CloseQuery():
        fServiceAdapter:CloseQuery().
    END METHOD.

	DESTRUCTOR PUBLIC PurchaseOrderForm ( ):
        CloseQuery().
		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.
	END DESTRUCTOR.

END CLASS.